/* Script Projet */
/* chargement des images "server" */
var SIchk = new Image();
var SIok = new Image();
var SIerr = new Image();
SIchk.src="data/adm/ctcchk.svg";
SIok.src="data/adm/ctcok.svg";
SIerr.src="data/adm/ctcerr.svg";
/* constantes */
const FLREST=1,FLSEETASK=2,FLDELTASK=4,FLNEWPROJ=8,FLDELPROJ=16,FLDELSCENE=32,FLDIRECT=64,FLCHGPASS=128;

/*----- default left mouse -------*/
function pj_leftmouse(event)
{

}
/*-- Exit -- */
function pj_exit(event)
{
	window.open("index.php?opt=nosplash", '_self');
}
/*-- Liste des scènes --*/
PJSceneList=[];
PJSelected=-1;
function pj_refreshscene()
{
	$.post("pjutil.php",{command:"listall"}, function (data) {
	var retour=_parse(data);
	if (retour[0]=="1")
	{
		PJSceneList=retour[1];	// retour avec un index vide au début, pour ajout
		for (var i=1;i<PJSceneList.length;i++)
		{
			if (PJSceneList[i][7])	PJSceneList[i][7]=_parse(PJSceneList[i][7]);
			else					PJSceneList[i][7]=new PSzero();
		}
		var square="<div id='sqscene0' onclick='pj_addscene(event);' class='scenesquare'>";
		square+="<div class='scenetele'><img id='tele0' src='data/square/tele.png' /></div>";
		square+="<div class='scenesquaretext'>"+_translate("Ajouter")+"</div><img class='scenesquareimg' src='data/square/clapperboardnew.svg' />"; //src='data/square/new.svg' />";

		// ajout de la barre d'avancement
		square+="<div id='barreautour'><div class='barregrise'></div>";
		square+="<div id='barrebleue' style='width:0em'></div>";
		square+="</div>";

		square+="</div>";
		$('#leftruban').append(square);
		pj_doTasks(1,retour[1]);
	}
	});
}
/* Effectuer la liste de tâches */
function pj_doTasks(idx,tasklist)
{
	for (var i=0;i<tasklist.length;i++)
	{
		var telem=tasklist[i];
		if (telem[0]==1)
		{
			// ajout
			square="<div id='sqscene"+idx+"' onclick='pj_selectscene(event,"+idx+");' class='scenesquare'>";
			square+="<div class='scenetele'><img id='tele"+idx+"' src='data/square/tele.png' /></div>";
			square+="<div class='scenesquaretext'>"+telem[2]+"<br><span style='font-size:.8em;'>"+telem[6]+"</span></div>";
			if (telem[1]=="commons")	square+="<img class='scenesquareimg' src='data/square/commons.svg' />";
			else
				if (telem[4])
				{
					var unique=new Date();
					square+="<img class='scenesquareimg' src='projects/"+PJProject+"/"+telem[1]+"/xs-"+telem[1]+".jpg?unique="+unique.getTime()+"'>";
					//square+="<img class='scenesquareimg' src='picloader.php?pic=projects/"+PJProject+"/"+telem[1]+"/xs-"+telem[1]+".jpg'>";
				}
				else				square+="<img class='scenesquareimg' src='data/square/clapperboard.svg'/>";	//scene.svg' />";
			if (telem[3])		square+="<div class='lockscene' style='display:block;'></div>";
			else				square+="<div class='lockscene' style='display:none;'></div>";
			square+="</div>";
			$('#leftruban').append(square);
			idx++;
		}
	}
}
var FontID="geosanslight";
var FontPicSize=40;
var FontZoom=40;
var FontColor="#000000";
var FontJustify=0;
var FontJTab=["left","center","right"];
var SceneTab=new Array();
/* click d'un square */
function pj_selectscene(event,id)
{
	if (id==0)	return;
	//var drawer=PJSceneList[id][1];
	if (PJSelected==id)
	{
 		$("#tele"+id).attr("src","data/square/tele.png");
		$("#sqscene"+id).insertAfter($("#sqscene"+(id-1)));
		PJSelected=-1;
		$("#leftpanel").css({"width":""});
		$("#middlepanel").hide();
	}
	else
	{
		if (PJSelected!=-1)
		{
			$("#tele"+PJSelected).attr("src","data/square/tele.png");
			$("#sqscene"+PJSelected).insertAfter($("#sqscene"+(PJSelected-1)));
		}
		PJSelected=id;
 		$("#tele"+id).attr("src","data/square/telesel.png");
		$("#leftpanel").css({"width":"11.2em"});
		$("#middlepanel").show();
		var scene="";
		/* == Barre menu scène == */
		scene+="<div id='stitle' class='barremenu' onclick='pj_swapderoul(\"deroulheader\");'>"+_translate("Scène")+"</div>";
		scene+="<div class='listederoul'  id='deroulheader' style='display:inline-block'>";
		/* block boutons */
		scene+="<div id='centermoumoute' class='sqdiv'>";
		/* répertoire autre que commun et pas locké */
		if (id>1 && !PJSceneList[id][3])
		{
			scene+="<div class='topmoumoute'>";
			scene+="<span class='sqspan'>"+_translate("Scène")+"</span>";
			scene+=pj_makebut(_translate("Éditeur"),"","#00A")+"<br>";
			scene+=pj_makebut(_translate("Supprimer"),"pj_suppr(event,"+id+");","red")+"</div>";
		}
		/* présence d'un mp4 */
		var chemin="projects/"+PJProject+"/"+PJSceneList[id][1]+"/";
		if (PJSceneList[id][5])
		{
			var unique=new Date();
			if (id!=1)	var video=chemin+PJSceneList[id][1]+".mp4";
			else			var video=chemin+PJProject+".mp4";
			scene+="<div id='bottommoumoute' class='bottommoumoute'>";
			scene+="<span class='sqspan'>"+_translate("Film")+"</span>";
			scene+="<a class='sqbutton' href='"+video+"' download=''>"+_translate("Télécharger")+"</a><br>";
			scene+=pj_makebut(_translate("Supprimer"),"pj_deletefilm(event,"+id+");","red")+"</div>";
			scene+="</div>";
			scene+="<div id='scenemovie' class='sqvid'>";
			scene+="<video controls src='"+video+"?unique="+unique.getTime()+"'>"+_translate("Vidéo")+"</video>";
			scene+="</div>";
		}
		else		scene+="</div>";
		if (id==1)
		{
			// ajout montage
			scene+="<div onclick='mnt_openWindow();' class='scenesquare'>";
			scene+="<div class='scenetele'><img src='data/square/tele.png' /></div>";
			scene+="<div class='scenesquaretext'>"+_translate("Montage")+"</div>";
			scene+="<img class='scenesquareimg' src='data/square/movediting.svg' />";
			scene+="</div>";
		}		
		scene+="</div>";
		/* == Barre menu image == */
		scene+="<div class='barremenu' onclick='pj_swapderoul(\"deroulimage\");'>"+_translate("Images")+"</div>";
		scene+="<div class='listederoul' id='deroulimage'>";
			scene+="<div class='sqbutton'><label><input id='imgloader' type='file' name='' accept='.jpg,.png,.jpeg,.svg' onchange='addimage(event);' multiple>"+_translate("Ajouter")+"</label></div>";
			scene+="<div id='divupload'>";
				scene+="<progress max='100' value='0' id='uploadbar'></progress></div>";
				scene+="<span id='upmsg'>"+_translate("En attente")+".</span>";
				scene+="<div class='listeinner' id='innerimage'><div id='listeimage'></div></div>";
			scene+="</div>";
		/* == Gestion du son ==*/
		scene+="<div class='barremenu' onclick='pj_swapderoul(\"deroulson\");'>"+_translate("Sons")+"</div>";
		scene+="<div class='listederoul' id='deroulson'>";
			scene+="<div class='sqbutton'><label><input id='sndloader' type='file' name='' accept='.mp3,.m4a,.wave,.aiff,.ogg,.wma' onchange='wa_addsound(event);' multiple>"+_translate("Ajouter")+"</label></div>";
			scene+="<div id='divuploadsnd'>";
				scene+="<progress max='100' value='0' id='uploadbarsnd'></progress></div>";
				scene+="<span id='upmsgsnd'>"+_translate("En attente")+"</span>";
				scene+="<div class='listeinner' id='innersound'><div id='listesons'></div></div>";
				scene+="<div class='brique'>"+pj_makebut(_translate("Enregistrer"),"wa_savezero();","red")+"</div>";
			scene+="</div>";
			/* == Barre menu Textes == */
			scene+="<div class='barremenu' onclick='pj_swapderoul(\"deroultxt\");'>"+_translate("Écritoire")+"</div>";
			scene+="<div class='listederoul'  id='deroultxt'>";
			scene+="<div class='formu'>";
				scene+=pam_selector(_translate("Police de caractères"),FontFamily,FontID,'pj_chgfnt',"fnt_family");
				scene+=pam_color(_translate("Couleur"),"fnt_color");
				scene+="<div id='fnjustify' style='background-image:url(\"data/adm/fn_"+FontJTab[FontJustify]+".svg\");' onclick='pj_justify();'></div>";
			scene+="</div>";
			scene+="<div class='formu'>";
				scene+=pam_range("fnzoom","fnzoomtxt",_translate("Zoom")+"&nbsp;:",FontZoom,FontZoom,15,200,5,"pj_chgfnzoom");
				scene+=pam_range("fnheight","fnheighttxt",_translate("Hauteur de l'image")+"&nbsp;:",FontPicSize,FontPicSize,20,720,10,"pj_chgfnheight");
			scene+="</div>";
			scene+="<div class='brique'>";
				scene+="<textarea onkeyup='pj_txtchg();' style='color:"+FontColor+";font-size:"+FontZoom+"px;font-family:\""+FontID+"\"' id='usertxt' spellcheck='true' wrap='off' cols='15'></textarea>";
			scene+="</div>";
			scene+="<div class='formu'>";
				scene+=_translate("Nom de l'image")+"&nbsp;: <input id='newimagetxt' value='' />";
				scene+=pj_makebut(_translate("Création"),"pj_newimagetxt();","#00A");
				scene+="<div id='fn_info' class='errordiv'></div>";
			scene+="</div>";
		scene+="</div>";

		/* == Barre menu fond & halo == */
		scene+="<div class='barremenu' onclick='pj_swapderoul(\"deroulhalo\");'>"+_translate("Fonds et halos")+"</div>";
		scene+="<div class='listederoul'  id='deroulhalo'>";
			scene+="<div class='formu'>";
			scene+="<div class='brique' style='text-align:right'>";
			scene+=pam_color(_translate("Couleur")+" 1","fh_color1")+"<br>";
			scene+=pam_color(_translate("Couleur")+" 2","fh_color2")+"<br>";
			scene+="<span>"+_translate("Dégradé")+" : </span><div id='fhgradient' style='background-image:url(\"data/adm/fh_"+svg_gradtab[svg_gradient]+".svg\");' onclick='pj_gradient();'></div>";
			scene+="</div>";
			scene+="<div id='drawbox'>";
			scene+=pj_gensvg(false);
			scene+="</div></div>";
			var prop=getprop();
			scene+=pam_range("fhprop","fhproptxt",_translate("Proportions")+"&nbsp;:",prop[0]+"/"+prop[1],svg_prop,5,95,1,"pj_chgfhprop");
			scene+=pam_range("fhsize","fhsizetxt",_translate("Taille")+"&nbsp;:",svg_sizetab[svg_size-1],svg_size,1,4,1,"pj_chgfhsize")+"<br>";
			scene+="<div class='formu'>";
				scene+=_translate("Nom de l'image")+"&nbsp;: <input id='newimagefh' value='' />";
				scene+=pj_makebut(_translate("Création"),"pj_newimagefh();","#00A");
				scene+="<div id='fh_info' class='errordiv'></div>";
			scene+="</div>";
		scene+="</div>";

		/* == Barre menu paramètres == */
		scene+="<div class='barremenu' onclick='pj_swapderoul(\"deroulparam\");'>"+_translate("Paramètres")+"</div>";
		scene+="<div class='listederoul'  id='deroulparam'>";
		//Paramètres variables
		/* dans commons longueur par défaut */
		if (id==1)
		{
			var duree=PJSceneList[id][7].length;
			scene+="<div class='formu'>"+pam_range("scenelength","scenesec",_translate("Durée initiale des scènes")+"&nbsp;:","("+duree+"s)",duree,5,60,5,"pj_chglength")+"</div>";
		}
		scene+="<div class='lego'>";
		scene+=pam_selector(_translate("Taille instantané"),["240p","360p","480p","540p","720p","1080p","1440p","2160p"],PJSceneList[id][7].photores+"p",'pj_photoreso',"photo_res")+"<br>";
		scene+=pam_selector(_translate("Format vidéo"),SceneTab,getshort(PJSceneList[id][7].factorx,PJSceneList[id][7].factory),"pj_animformat","video_fmt");
		scene+="</div>";
		scene+="<div class='brique'><img id='fmtexemple' src='data/formats/169.JPG'/></div>";
		scene+="<div class='formu'>";
		/* enregistrement de la valeur */
		if (id==1 && !PJSceneList[id][3])	scene+="<div class='brique'>"+pj_makebut(_translate("Éditer modèle"),"","#00A")+"</div>";
		scene+="<div class='brique'>"+pj_makebut(_translate("Enregistrer"),"pj_savezero(event,"+id+");","red")+"</div></div>";
		scene+="<div id='fu_info' class='brique'></div>";
		scene+="</div>";
		/* == Total == */
		$("#middleruban").html(scene);
		if (!PJSceneList[id][5] && id==1)	$('#centermoumoute').hide();
		pj_listeimage();
		pj_animformat();
		wa_listesons();
		$("#deroulheader").prepend($("#sqscene"+id));
		$("#selectedscene").val(PJSceneList[id][1]);
		$('#innerimage').css('max-height',MaxH-220);
		$('#innersound').css('max-height',MaxH-220);
		// Couleurs
		$("#fnt_color").spectrum({
			cancelText: _translate("annuler"),
			chooseText: _translate("choisir"),
			color: FontColor,
			change: function(color) {
			pj_chgfncolor(color.toHexString());
		}
		});
		$("#fh_color1").spectrum({
			cancelText: _translate("annuler"),
			chooseText: _translate("choisir"),
			color: svg_col1,
			showAlpha: true,
			change: function(color) {
			pj_chgfhcolor1(color.toHex8());
		}
		});
		$("#fh_color2").spectrum({
			cancelText: _translate("annuler"),
			chooseText: _translate("choisir"),
			color: svg_col2,
			showAlpha: true,
			change: function(color) {
			pj_chgfhcolor2(color.toHex8());
		}
		});
	}
}
/* création d'une image halo */
function pj_newimagefh()
{
	// nom de l'image
	var name=$("#newimagefh").val();
	/* filtrer le nom */
	name=name.replace(/"/g,"");		// chars interdits
	name=name.replace(/>/g,"");		// chars interdits
	name=name.replace(/</g,"");		// chars interdits
	name=name.replace(/`/g,"");		// chars interdits
	name=name.replace(/ /g,"_");
	name=name.substr(0,20);
	$("#newimagefh").val(name);
	// controles
	if (name.length<1)
	{
		$("#fh_info").html(_translate("Donnez un nom valide à l'image !"));
		return;
	}
	$("#fh_info").html("<span style='color:white'>"+_translate("Patientez")+"...</span>");
	var svg=pj_gensvg(true);
	var drawer=PJSceneList[PJSelected][1];
	$.post("pjutil.php",{command:"newfhimage",scene:drawer,imagename:name,imagesvg:svg}, function (data) {
		var retour=_parse(data);
		if (retour[0]==0)
		{
			$("#fh_info").html(retour[1]);
		}
		else
		{
			$("#fh_info").html("<span style='color:white'>"+retour[1]+"</span>");
			$('#listeimage').html("");
			pj_listeimage();
		}
		//console.log(data);
	});
}
/* PJ Gradient */
function pj_gradient()
{
	// reset prop
	$("#fhprop").val(50);
	pj_chgfhprop();
	// gradient
	svg_gradient++;
	if(svg_gradient==2)	svg_gradient=0;
	$("#fhgradient").css("background-image","url(\"data/adm/fh_"+svg_gradtab[svg_gradient]+".svg\"");
	$("#svg_form").css("fill","url('#fh_"+svg_gradtab[svg_gradient]+"')");

}
/* color*/
function pj_chgfhcolor1(color)
{
	svg_col1=color;
	$("#svg_stop1").css("stop-color",getcolor(svg_col1));
	$("#svg_stopr1").css("stop-color",getcolor(svg_col1));
	$("#svg_stop1").css("stop-opacity",gettrans(svg_col1));
	$("#svg_stopr1").css("stop-opacity",gettrans(svg_col1));
}
function pj_chgfhcolor2(color)
{
	svg_col2=color;
	$("#svg_stop2").css("stop-color",getcolor(svg_col2));
	$("#svg_stopr2").css("stop-color",getcolor(svg_col2));
	$("#svg_stop2").css("stop-opacity",gettrans(svg_col2));
	$("#svg_stopr2").css("stop-opacity",gettrans(svg_col2));
}
/* proportions */
function pj_chgfhprop()
{
	svg_prop=$("#fhprop").val();
	var prop=getprop();
	$("#svg_svg").attr("width",(prop[0]*2)+"");
	$("#svg_svg").attr("height",(prop[1]*2)+"");
	$("#fhproptxt").html(prop[0]+"/"+prop[1]);
}
/* taille */
function pj_chgfhsize()
{
	svg_size=$("#fhsize").val();
	$("#fhsizetxt").html(svg_sizetab[svg_size-1]);
}
/* génération d'un svg */
		//cx="50%" cy="50%" r="50%" 
var svg_prop=50;
var svg_col1="FF0000FF";
var svg_col2="000000FF";
var svg_gradient=0;
var svg_gradtab=["linear","radial"];
var svg_size=2;
var	svg_sizetab=new Array();
function pj_gensvg(image)
{
	var prop=getprop();
	if (image)
	{
		prop[0]*=4*svg_size;
		prop[1]*=4*svg_size;
	}
	else
	{
		prop[0]*=2;
		prop[1]*=2;
	}
	/* création */
	var svg="<svg id='svg_svg' x='0' y='0' height='"+prop[1]+"px' width='"+prop[0]+"px'>";
	svg+="<defs>";

	svg+="<linearGradient y2='100%' x2='0' y1='0' x1='0' id='fh_linear'>";
	svg+="<stop id='svg_stop1' offset='0' style='stop-color:"+getcolor(svg_col1)+";stop-opacity:"+gettrans(svg_col1)+";'/>";
	svg+="<stop id='svg_stop2' offset='1' style='stop-color:"+getcolor(svg_col2)+";stop-opacity:"+gettrans(svg_col2)+";'/>";
	svg+='</linearGradient>';

	svg+="<radialGradient cy='50%' cx='50%' r='50%' id='fh_radial'>";
	svg+="<stop id='svg_stopr1' offset='0' style='stop-color:"+getcolor(svg_col1)+";stop-opacity:"+gettrans(svg_col1)+";'/>";
	svg+="<stop id='svg_stopr2' offset='1' style='stop-color:"+getcolor(svg_col2)+";stop-opacity:"+gettrans(svg_col2)+";'/>";
	svg+='</radialGradient></defs>';

	svg+="<g><rect id='svg_form' height='100%' width='100%' ";
	if (!image)	svg+="style='opacity:1;fill:url(#fh_"+svg_gradtab[svg_gradient]+");stroke:black;stroke-width:3px;stroke-dasharray:5; stroke-opacity:1;'/></g></svg>";
	else		svg+="style='opacity:1;fill:url(#fh_"+svg_gradtab[svg_gradient]+");stroke-width:0;'/></g></svg>";
	return svg;
}
function gettrans(color)
{
	var trans=color.slice(0,2);
	trans=parseInt(trans,16);
	trans=trans/255;
	return ""+trans;
}
function getcolor(color)
{
	return	"#"+color.slice(2);
}

function getprop()
{
	/* calcul des proportions */
	var width,height;
	if (svg_prop<=50)
	{
		width=100*svg_prop/50;
		height=100;
	}
	else
	{
		width=100;
		height=100*((100-svg_prop)/50);
	}
	width=Math.round(width);
	height=Math.round(height);
	return [width,height];
}
/* création d'une image police */
function pj_newimagetxt()
{
	// nom de l'image
	var name=$("#newimagetxt").val();
	/* filtrer le nom */
	name=name.replace(/"/g,"");		// chars interdits
	name=name.replace(/>/g,"");		// chars interdits
	name=name.replace(/</g,"");		// chars interdits
	name=name.replace(/`/g,"");		// chars interdits
	name=name.replace(/ /g,"_");
	name=name.substr(0,20);
	$("#newimagetxt").val(name);

	// hauteur de l'image et Texte
	var text=$("#usertxt").val();
	// controles
	if (text.length<1)
	{
		$("#fn_info").html(_translate("Il n'y a pas de texte !"));
		return;
	}
	if (name.length<1)
	{
		$("#fn_info").html(_translate("Donnez un nom valide à l'image !"));
		return;
	}
	name+=".png";
	var ltext=text.split("\n" ).length;
	ltext=ltext*FontPicSize;
	//var FontID="geosanslight";
	//var FontPicSize=40;
	//var FontColor="#000000";
	//var FontJustify=0;
	//var FontJTab=["left","center","right"];
	$("#fn_info").html("<span style='color:white'>"+_translate("Patientez")+"...</span>");
	var drawer=PJSceneList[PJSelected][1];
	$.post("pjutil.php",{command:"newtxtimage",scene:drawer,imagename:name,imagetxt:text,fontname:FontID,imagesize:ltext,fontcolor:FontColor,gravity:FontJTab[FontJustify]}, function (data) {
		var retour=_parse(data);
		if (retour[0]==0)
		{
			$("#fn_info").html(retour[1]);
		}
		else
		{
			$("#fn_info").html("<span style='color:white'>"+retour[1]+"</span>");
			$('#listeimage').html("");
			pj_listeimage();
		}
		//console.log(data);
	});
}
/* hauteur du dessin */
function pj_chgfnheight()
{
	FontPicSize=$("#fnheight").val();
	//$("#fnheighttxt").html(FontPicSize);
	pj_txtchg();
}
/* touche détectée */
function pj_txtchg()
{
	/* compter les caractères */
	var text=$("#usertxt").val();
	var ltext=text.split("\n" ).length;
	//var ltext=text.length;
	ltext=ltext*FontPicSize;
	$("#fnheighttxt").html(ltext+"px");
}
/* changer taille police */
function pj_chgfnzoom()
{
	FontZoom=$("#fnzoom").val();
	$("#fnzoomtxt").html(FontZoom);
	$("#usertxt").css("font-size",FontZoom+"px");
}
/* changer couleur police */
function pj_chgfncolor(color)
{
	FontColor=color;
	$("#usertxt").css("color",FontColor);
}
/* changer police */
function pj_chgfnt()
{
	FontID=$("#fnt_family option:selected").val();
	console.log(FontID);
	$("#usertxt").css("font-family",FontID);
}
/* justifier */
function pj_justify()
{
	FontJustify++;
	if (FontJustify==3)	FontJustify=0;
	$("#usertxt").css("text-align",FontJTab[FontJustify]);
	$("#fnjustify").css("background-image","url('data/adm/fn_"+FontJTab[FontJustify]+".svg')");
}
/* changer durée */
function pj_chglength()
{
	var value=$("#scenelength").val();
	PJSceneList[PJSelected][7].length=value;
	$("#scenesec").html("("+value+"s)");
}
/* s/p save zero */
function pj_savezero(id)
{
	var name=PJSceneList[PJSelected][1];
	$.post("pjutil.php",{command:"chgzero",scenename:name,anim:JSON.stringify(PJSceneList[PJSelected][7])}, function (data) {
	var retour=_parse(data);
	if (retour[0]==1)
	{
		$('#fu_info').html(_translate("Enregistré"));
	}
	else
	{
		/* afficher l'erreur */
		$('#fu_info').html(retour[1]);
	}
	});	
}
/* sous-prog de sélection */
function pj_photoreso()
{
	var value=$("#photo_res option:selected").val();
	PJSceneList[PJSelected][7].photores=value.replace("p", "");
}
function pj_animformat()
{
	var value=$("#video_fmt option:selected").val();
	var picname;
	var x,y;
	switch (value)
	{
		case SceneTab[0]:
			x=16;
			y=9;
			picname="169.JPG";
			break;
		case SceneTab[1]:
			x=4;
			y=3;
			picname="43.JPG";
			break;
		case SceneTab[2]:
			x=2.35;
			y=1;
			picname="Cinema.JPG";
			break;
		case SceneTab[3]:
			x=1;
			y=1;
			picname="Carre.JPG";
			break;
		case SceneTab[4]:
			x=9;
			y=16;
			picname="Portrait.JPG";
			break;
		default:
			x=16;
			y=9;
			picname="169.JPG";
	}
	PJSceneList[PJSelected][7].factorx=x;
	PJSceneList[PJSelected][7].factory=y;
	// changer apparence image
	$("#fmtexemple").attr("src","data/formats/"+picname);
}
/* dresser la liste des images */
function pj_listeimage()
{
	pj_lock("deroulimage");
	var drawer=PJSceneList[PJSelected][1];
	$.post("pjutil.php",{command:"listimage",scene:drawer}, function (data) {
	var retour=_parse(data);
	if (retour[0]==1)	pj_addimages(retour[1]);
	pj_unlock();
	});
}
// point rouge si occupé
PJBar=0;
function pj_lock(id)
{
	if (!PJBar)		PJBar=$("<div id='barremenubusy'></div>");
	$("#"+id).append(PJBar);
	$("#barremenubusy").show();
}
function pj_unlock()
{
	$("#barremenubusy").hide();
}
	// ajouter en #listeimage
function pj_addimages(liste)
{
	var chemin="projects/"+PJProject+"/"+PJSceneList[PJSelected][1]+"/";
	for (i=0;i<liste.length;i++)
	{
		var imag="";
		imag+="<div class='li_div' id='image-"+i+"'>";
		imag+="<div class='li_quadri' onclick='pj_showimage(\""+liste[i][1]+"\")'><img src='"+chemin+"/image/xs-"+liste[i][1]+"' /></div>";
		imag+="<div class='li_txt'>";
		imag+="<div class='li_txt' style='display:block'>"+liste[i][1]+"</div>";
		imag+="<div class='li_txt'>"+liste[i][2]+"X"+liste[i][3]+"</div>";
		imag+="<div class='li_txt'>"+liste[i][4]+"</div>";
		imag+="<div class='li_txt'>"+liste[i][5]+"</div>";
		imag+="</div><div class='li_trash' onclick='pj_deleteimage(event,\""+liste[i][1]+"\","+i+")'></div></div>";
		$('#listeimage').append(imag);
	}
}
/* afficher image en grand */
function pj_showimage(image)
{
	if (!image)
	{
		$("#displayimage").hide();
		return;
	}
	var pic="projects/"+PJProject+"/"+PJSceneList[PJSelected][1]+"/image/"+image;
	var pop="<img style='max-width:100%;' src='"+pic+"'/>";
	/* display */
	$("#displayimage").html(pop);
	$("#displayimage").show();
}
/* supprimer image dialog */
function pj_deleteimage(event,image,id)
{
	if (pj_closepop())	return;
	var pic="projects/"+PJProject+"/"+PJSceneList[PJSelected][1]+"/image/"+image;
	var pop="";
	pop+="<h1>"+_translate("Supprimer une image")+"</h1>";
	pop+="<div class='smallimg' style='margin-bottom:5px;'><img src='"+pic+"' width='100%'></div>"
	pop+="<p>"+_translate("Êtes-vous bien sûr de vouloir supprimer :")+"<br>";
	pop+="<b>"+image+"</b>&nbsp;?</p>";
	pop+="<p>"+_translate("Attention, si cette image est utilisée dans la scène, celle-ci devra être modifiée !")+"</p>";
	pop+="<div class='errordiv' id='fu_err'></div>";
	pop+="<div id='leftbutton' onclick='pj_closepop();'>"+_translate("Annuler")+"</div>";
	pop+="<div id='rightbutton' onclick='pj_supprimagevalid(\""+image+"\","+id+");' style='color:red'>"+_translate("Supprimer")+"</div>";
	pop+="</div>";
	/* display */
	$("#popup").html(pop);
	//$("#popup").show();
	ShowPop(true);
	event.preventDefault();
}
function pj_supprimagevalid(image,id)
{
	var name=PJSceneList[PJSelected][1];
	$('#fu_errproj').html("");
	$.post("pjutil.php",{command:"supprpic",scenename:name,imagename:image}, function (data) {
	var retour=_parse(data);
	if (retour[0]=="1")
	{
		/* supprimer dans la liste */
		$('#image-'+id).remove();
		pj_closepop();
	}
	else
	{
		/* afficher l'erreur */
		$('#fu_err').html(retour[1]);
	}
	});	
}
/* supprimer video dialog */
function pj_deletefilm(event,id)
{
	if (pj_closepop())	return;
	var film="projects/"+PJProject+"/"+PJSceneList[PJSelected][1]+"/"+PJSceneList[PJSelected][1]+".mp4";
	var pop="";
	pop+="<h1>"+_translate("Supprimer le film")+"</h1>";
	if (id!=1)
	{
		pop+="<p>"+_translate("Êtes-vous bien sûr de vouloir supprimer le film de la scène")+"&nbsp;";
		pop+="<b>"+PJSceneList[PJSelected][2]+"&nbsp;?</b></p>";
	}
	else
	{
		pop+="<p>"+_translate("Êtes-vous bien sûr de vouloir supprimer le film du projet")+"&nbsp;";
		pop+="<b>"+PJProject+"&nbsp;?</b></p>";
	}
	pop+="<div class='errordiv' id='fu_err'></div>";
	pop+="<div id='leftbutton' onclick='pj_closepop();'>"+_translate("Annuler")+"</div>";
	pop+="<div id='rightbutton' onclick='pj_delfilmvalid("+id+");' style='color:red'>"+_translate("Supprimer")+"</div>";
	pop+="</div>";
	/* display */
	$("#popup").html(pop);
	//$("#popup").show();
	ShowPop(true);
	event.preventDefault();
}
function pj_delfilmvalid(id)
{
	var name=PJSceneList[PJSelected][1];
	$('#fu_errproj').html("");
	$.post("pjutil.php",{command:"supprfilm",scenename:name}, function (data) {
	var retour=_parse(data);
	if (retour[0]=="1")
	{
		$('#bottommoumoute').remove();
		$('#scenemovie').remove();
		if (id==1)		$('#centermoumoute').hide();
		PJSceneList[id][5]=false;
	}
	});
	pj_closepop();
}
/* afficher / cacher */
function pj_swapderoul(id)
{
	var actu=$("#"+id).css('display');
	$('.listederoul').css("display","none");
	$('#upmsg').html(_translate("En attente"));
	if (actu == "none")				$("#"+id).css("display","inline-block");
	// si deroulheader enroulé, changer stitle
	if (id=="deroulheader")	$("#stitle").html(_translate("Scène"));
	else					$("#stitle").html(_translate("Scène")+" ("+PJSceneList[PJSelected][2]+")");
}
/* ajout d'une scene */
function pj_addscene(event)
{
	if (pj_closepop())	return;
	var pop="";
	pop=pop+"<h1>"+_translate("Ajouter une scène")+"</h1>";
	pop+="<div class='formu'><span class='tabspan'>"+_translate("Nom de la scène")+"&nbsp;: </span>";
	pop+="<input id='fu_iname'></div>";
	/* Boutons */
	pop+="<div class='errordiv' id='fu_err'></div>";
	pop+="<div class='formu'>";
	pop+="<div id='leftbutton' onclick='pj_closepop();'>"+_translate("Annuler")+"</div>";
	pop+="<div id='rightbutton' onclick='pj_addscenevalid(event);'>"+_translate("Ajouter")+"</div>";
	pop+="</div>";
	/* display */
	$("#popup").html(pop);
	ShowPop(true);
	inputfocus("fu_iname");
	$('#popup').keypress(function(e){if (e.which==13) pj_addscenevalid(e)});
}
function pj_addscenevalid(event)
{
	var name=$("#fu_iname").val();
	/* filtrer le nom */
	name=name.replace(/"/g,"");		// chars interdits
	name=name.replace(/>/g,"");		// chars interdits
	name=name.replace(/</g,"");		// chars interdits
	name=name.replace(/`/g,"");		// chars interdits
	$("#fu_iname").val(name);

	// réduire à 20 chars max
	var filtred=name.substr(0,20);
	filtred=filtred.replace(/ /g,"_");
	filtred=filtred.replace(/'/g,"");
	filtred=replaceDiacritics(filtred);
	if (name=="" || filtred=="")
	{
		$('#fu_err').html(_translate("Rentrez un nom valide !"));
		return;
	}
	$('#fu_err').html("");
	/* anim pipo */
	var blankproj=new Array();
	blankproj[0]=new PSzero();

	$.post("pjutil.php",{command:"addscene",scenename:name,drawername:filtred,anim:JSON.stringify(blankproj)}, function (data) {
	var retour=_parse(data);
	if (retour[0]==1)
	{
		/* ajouter dans la liste */
		var idx=PJSceneList.length;
		PJSceneList[idx]=retour[1];
		PJSceneList[idx][7]=_parse(PJSceneList[idx][7]);
		//console.log(PJSceneList[idx]);
		var task=new Array();
		task[0]=retour[1];
		pj_doTasks(idx,task);
		pj_closepop();
		pj_selectscene(0,idx);
	}
	else
	{
		/* afficher l'erreur */
		$('#fu_err').html(retour[1]);
	}
	});	
}
/* Faire un bouton */
function pj_makebut(txt,command,color)
{
	if (command=='')
	{
		return "<div class='sqbutton' onClick='javascript:document.forms[0].submit();' style='color:"+color+"'><span>"+txt+"</span></div>";
	}
	return "<div class='sqbutton' onclick='"+command+"' style='color:"+color+"'><span>"+txt+"</span></div>";
}
/* supprimer */
function pj_suppr(event,id)
{
	if (pj_closepop())	return;
	var pop="";
	pop=pop+"<h1>"+_translate("Supprimer la scène")+" &laquo;&nbsp;"+PJSceneList[id][2]+"&nbsp;&raquo;</h1>";

	/* mot de passe si besoin */
	if ((ADMFlags&FLDELSCENE) && (ADMFlags&FLREST))
	{
		pop+="<div class='formuc' id='fu_dmdp'>"
		pop+="<div class='formu'><span class='tabspan'>"+_translate("Mot de passe administrateur")+"</span>";
		pop+="<input id='fu_imdp' type='password'></div>";
		pop+="</div>";
	}
	/* Boutons */
	pop+="<div class='errordiv' id='fu_errproj'></div>";
	pop+="<div class='formu'>";
	pop+="<div id='leftbutton' onclick='pj_closepop();'>"+_translate("Annuler")+"</div>";
	pop+="<div id='rightbutton' onclick='pj_supprscene(event);' style='color:red'>"+_translate("Supprimer")+"</div>";
	pop+="</div>";
	/* display */
	$("#popup").html(pop);
	ShowPop(true);
	inputfocus("fu_dmdp");
}
/* -- supprimer une scene -- */
function pj_supprscene(event)
{
	var mdp=$("#fu_imdp").val();
	var name=PJSceneList[PJSelected][1];
	$('#fu_errproj').html("");
	$.post("pjutil.php",{command:"supprscene",password:mdp,scenename:name}, function (data) {
	var retour=_parse(data);
	if (retour[0]=="1")
	{
		/* supprimer dans la liste */
		PJSceneList[PJSelected]=[];
		$("#sqscene"+PJSelected).remove();
		PJSelected=-1;
		$("#leftpanel").css({"width":""});
		$("#middlepanel").hide();
		pj_closepop();
	}
	else
	{
		/* afficher l'erreur */
		$('#fu_errproj').html(retour[1]);
	}
	});	
}
/*-- ajouter image --*/
function addimage(event)
{
	var image=event.target.files;
	var data = new FormData();
	idx=0;
	data.append("project",PJProject);
	data.append("scene",PJSceneList[PJSelected][1]);
	while (image[idx]!=undefined)	data.append('img-'+idx,image[idx++]);
	// progress bar
	$("#uploadbar").show();
	$('#upmsg').html(_translate("Chargement en cours")+" ("+image.length+")");
	// upload
	$.ajax({
		url: 'pjupload.php',
		data: data,
		cache: false,
		contentType: false,
		processData: false,
		type: 'POST',
		xhr: function() {
			var myXhr = $.ajaxSettings.xhr();
			if (myXhr.upload)	myXhr.upload.addEventListener('progress',up_progress, false);
			return myXhr;},
		success: up_success
	});
}
/* hooks */
function up_progress(event)
{
	$('#uploadbar').attr("max",event.total);
	$('#uploadbar').val(event.loaded);
	if (event.loaded==event.total)	$('#upmsg').html(_translate("Conversion des images..."));
}
function up_success(result)
{
	//console.log(result);
	$("#uploadbar").hide();
	if (result.indexOf("<b>Warning</b>")!=-1)
	{
		$('#upmsg').html(_translate("Avertissement : erreur de chargement !"));
		return;
	}
	var retour=_parse(result);
	if (retour[1])
	{
		$('#listeimage').html("");
		pj_listeimage();
		pj_rename(_parse(retour[1]));
	}
	if (retour[0])	$('#upmsg').html(_translate("Il y a eu des erreurs !")+"("+retour[0]+")");
	else			$('#upmsg').html(_translate("Chargement terminé !"));
}
/* renommage des images */
var PJLIOrig=0;
var PJLIRename=0;
function pj_rename(liste)
{
	// création fenêtre pop pour renommage et appel fonction rename
	PJLIOrig=liste;
	PJLIRename=new Array();
	// afficher fenêtre de renommage
	var pop="";
	pop+="<h1>"+_translate("Renommer des images téléchargées dans :")+" &laquo;&nbsp;"+PJSceneList[PJSelected][2]+"&nbsp;&raquo;</h1>";
	pop+="<div id='' class='formu'><div id='anybutton' onclick='pj_clean("+liste.length+");'><img src='data/newicons/clean.svg'></div></div>";
	pop+="<div class='formuc'>";
	/* boucle sur les images */
	var chemin="projects/"+PJProject+"/"+PJSceneList[PJSelected][1]+"/";
	for (i=0;i<liste.length;i++)
	{
		PJLIRename[i]=pj_fileinfo(liste[i]);
		pop+="<div class='li_div'>";
		pop+="<div class='li_quadri'><img src='"+chemin+"/image/xs-"+liste[i]+"' /></div>";
		pop+="<div class='li_txt'>";
		pop+="<div class='li_txt' style='display:block'>"+liste[i]+"</div>";
		pop+="<div class='li_txt'>"+_translate("Renommer en")+"&nbsp;: <input id='rnimage-"+i+"' value='"+PJLIRename[i][0]+"' />."+PJLIRename[i][1]+"</div>";
		pop+="</div></div>";
	}
	pop+="</div>";
	/* Boutons */
	pop+="<div class='errordiv' id='fu_errproj'></div>";
	pop+="<div class='formu'>";
	pop+="<div id='leftbutton' onclick='pj_closepop();'>"+_translate("Annuler")+"</div>";
	pop+="<div id='rightbutton' onclick='pj_renamevalid()'>"+_translate("Renommer")+"</div>";
	pop+="</div>";
	/* display */
	$("#popup").html(pop);
	ShowPop(true);	//$("#popup").show()
	inputfocus("rnimage-0");
	$('#popup').keypress(function(e){if (e.which==13) pj_renamevalid()});
}

function pj_clean(nb)
{
	for (i=0;i<nb;i++)	$("#rnimage-"+i).val("");
}
/* Rename dans liste */
function pj_renamevalid()
{
	// changer les noms
	var nb=0;
	var NewList=new Array();
	for (var i=0;i<PJLIOrig.length;i++)
	{
		var fullname=$("#rnimage-"+i).val();
		if (fullname)
		{
			fullname+="."+PJLIRename[i][1];
			NewList[i]=fullname;
			if (NewList[i]==PJLIOrig[i])	NewList[i]=false;
			else							nb++;
		}
		else
		{
			NewList[i]=false;
		}
	}
	// nb de changements
	//console.log(nb+" changements");
	if (nb)
	{
		var name=PJSceneList[PJSelected][1];
		$.post("pjutil.php",{command:"renameimg",scenename:name,files:PJLIOrig,newname:NewList}, function (data) {
		var retour=_parse(data);
		if (retour[0]=="1")
		{
			$('#listeimage').html("");
			pj_listeimage();
		}
		});
	}
	pj_closepop();
}
/* info filename */
function pj_fileinfo(name)
{
	var tab=name.split('.');
	var base=new Array();
	if (tab.length<2)
	{
		base[0]=name;
		base[1]="";
	}
	else
	{
		base[0]="";
		for (var i=0;i<(tab.length-1);i++)	base[0]+=tab[i];
		base[1]=tab[i];
	}
	return base;
}
/*----- Popup ------*/
function pj_closepop()
{
	if ($("#grise").css('display') == "block")
	{
		$('#popup').keypress("");
		$('#popup').css("overflow","");
		ShowPop(false);		//$("#popup").hide();
		return true;
	}
	return false;
}
/*---- Ping ----*/
var PINGdate=0;
function pj_ping()
{
	// début ping
	PINGdate=Date.now();
	// Afficher icône serveur
	$("#titleright").css("background-image","url('data/adm/ctcchk.svg')");
	// envoi ping
	$.post("idxping.php",{command:"ping"})
	.done(function (data) {
	var retour=_parse(data);
	var	ping=Date.now()-PINGdate;
	if (retour[1]=="pong")
	{
		$("#titleright").html(ping+" ms");
		$("#titleright").css("background-image","url('data/adm/ctcok.svg')");
		// pourcentage de la barre
		pj_progress(retour[2]);
	}
	else
	{
		$("#titleright").html(_translate("erreur"));
		$("#titleright").css("background-image","url('data/adm/ctcerr.svg')");
	}
		
	})
	.fail (function (data) {
		$("#titleright").html(_translate("erreur"));
		$("#titleright").css("background-image","url('data/adm/ctcerr.svg')");
	});
	setTimeout(function (){
	$("#titleright").css("background-image","url('data/adm/ctcoff.svg')");
	},2000);
}
var PINGidx=0;
var PINGdrawer="";
/* barre de progression */
function pj_progress(data)
{
	/* pas de travaux en cours */
	if (!PINGidx && !data)	return;
	if (PINGidx && !data)
	{
		PINGidx=0;
		PINGdrawer="";
		$("#barreautour").hide();
		return;
	}
	/* travail en cours */
	var avance=_parse(data);
	// concerné ?
	if (avance[0]==PJProject)
	{
		if (avance[1]!=PINGdrawer)
		{
			// recherche de PINGdrawer
			// A FAIRE Tester si existence des scènes !
			PINGidx=pj_findidx(avance[1]);
			if (!PINGidx)	return;
			PINGdrawer=avance[1];
			$("#sqscene"+PINGidx).append($("#barreautour"));
			$("#barreautour").show();
		}
	}
	else
	{
		// pas concerné
		if (PINGidx)
		{
			PINGidx=0;
			PINGdrawer="";
			$("#barreautour").hide();
		}
		return;
	}
	/* modif barre */
	var pc=9*(avance[2]/avance[3]);
	if (pc>9)	pc=9;
	$("#barrebleue").css("width",pc+"em");
}
/* trouver index */
function pj_findidx(drawer)
{
	var liste=PJSceneList;
	var idx=2;
	var limit=liste.length;
	while (idx<liste.length && liste[idx][1]!=drawer)	idx++;
	if (idx==liste.length)	idx=0;
	return idx;
}
/* fonction parse sécurisée */
function _parse(string)
{
	try {
	return	JSON.parse(string);
	} catch (e) {
	console.log(e.message);
	console.log(string);
	alert("Internal error : "+string);
	return false;
	}
}
/* compositeur de sélection */
function pam_selector(txt,lst,val,func,id)
{
	var retour="";
	retour+= "<div class='brique'>"+txt+"&nbsp;: ";
	retour+="<SELECT id='"+id+"' value='"+val+"' onchange='"+func+"();'>";
	lst.forEach(function (elem) {
		if (val==elem)	retour+="<OPTION selected>"+elem;
		else				retour+="<OPTION>"+elem;
	});
	retour+="</SELECT></div>";
	return retour;
}
/* compositeur de range */
function pam_range(inputID,spanID,rgtitle,rgtext,rgvalue,rgmin,rgmax,rgstep,rgfunction)
{
	var retour="<div class='brique'><span>"+rgtitle+"</span>";
	retour+="<input id='"+inputID+"' type='range' value='"+rgvalue+"' oninput='"+rgfunction+"();' max='"+rgmax+"' min='"+rgmin+"' step='"+rgstep+"'>";
	retour+="<span id='"+spanID+"'>"+rgtext+"</span></div>";
	return retour;
}
/* compositeur de couleur */
//pam_color("Couleur","AA45FF",'pj_chgcolor',"fnt_color");
function pam_color(cltitle,clid)
{
	var retour="<div class='brique'>"+cltitle+"&nbsp;: ";
	retour+="<input id='"+clid+"'>";
	retour+="</div>";
	return retour;
}
/* getshort, renvoyer format court */
function getshort(fx,fy)
{
	if (fx==16&&fy==9)		return SceneTab[0];
	if (fx==4&&fy==3)		return SceneTab[1];
	if (fx==2.35&&fy==1)	return SceneTab[2];
	if (fx==fy)				return SceneTab[3];
	if (fx==9&&fy==16)		return SceneTab[4];
	return SceneTab[0];
}

/*----------------- Préparation de la page ------------------*/
function ShowPop(state)
{
	if (state)
	{
		$("#grise").show();
		$("#popup").show();
	}
	else		$("#grise").hide();
}

var PINGtask=0;
function ps_ready()
{
	svg_sizetab=[_translate("Petit"),_translate("Moyen"),_translate("Grand"),_translate("Très grand")];
	SceneTab=["16:9","4:3",_translate("Cinéma"),_translate("Carré"),_translate("Portrait")];
	ps_resize();
	pj_refreshscene();
	//pj_ping();
	PINGtask=setInterval(pj_ping,10000);
	var PINGfirst=setTimeout(pj_ping,1000);
}
var MaxH=0;
function ps_resize()
{
	var h=$(window).height();
	MaxH=h;
	$("#maindiv").height(h);
	$("#grise").height(h);
}
/* Mise en place des scripts automatiques */
$(document).ready(ps_ready);
$(window).resize(ps_resize);











