/*--------- Partie animation --------*/
var PSAnimTPS,PSAnimNB;				// compteur de perfs

// interval d'animation
function ps_animInit()
{
	if (PSanimEvent)
	{
		ps_stopAnim();
		return;
	}

	PSanimTime=PSactualTime;
	PSAnimTPS=PSAnimNB=0;

	$("#div-time").show();
	$("#actual-fps").html("--");
	$("#div-fps").show();

	$("#bpplay").css("background-image","url('data/newicons/tl_stop.svg')");
	$("#popuplock").html("");
	$("#popuplock").css("background-color","rgba(0,0,0,0)");
	$("#popuplock").show();

	if (_O(0).snd&&WAsoundFlag)
	{
		PSplayer.currentTime=parseFloat(PSactualTime+_O(0).sndstrt);
		PSplayer.play();
	}
		var d=new Date();
		PSRefTime=d.getTime();
		OldTime=0;
		PSslow=0;
		if (!WAsoundFlag)		PSanimEvent=setInterval(ps_animEvent,(100/6));
		else								PSanimEvent=setInterval(ps_animEvent,(100/5));
}


function ps_stopAnim()
{
	if (!PSanimEvent)	return;
	if (_O(0).snd && WAsoundFlag)		PSplayer.pause();
	$("#div-time").hide();
	$("#div-fps").hide();
	clearInterval(PSanimEvent);
	PSanimEvent=0;
	$("#bpplay").css("background-image","url('data/newicons/tl_play.svg')");
	$("#popuplock").hide();
	// Afficher les performances
	// PSAnimTPS
	if (PSAnimNB&&PSAnimTPS)
	{
		var perf=parseInt(1000/(PSAnimTPS/PSAnimNB));
		ps_Msg(_translate("Performance moyenne")+" : "+perf+" fps",false);
	}
}
var PSRefTime=0;
var OldTime=0;
var PSslow=0
function ps_animEvent()
{
	var d=new Date();
	var add=d.getTime()-PSRefTime;

	PSactualTime=parseFloat(PSanimTime)+(add/1000);

	// tester si décalage son
	if (WAsoundFlag && (PSactualTime-PSplayer.currentTime+_O(0).sndstrt)>.5 && PSactualTime<(_O(0).sndlen-_O(0).sndstrt))
	{
		PSplayer.currentTime=PSactualTime+_O(0).sndstrt;
		 ef_feedback(-1);
	}

	if (OldTime!=0)
	{
		var tps=d.getTime()-OldTime;
		PSAnimTPS+=tps;
		PSAnimNB++;
		tps=parseInt(1000/tps);
		if (!PSslow || tps<15)	$("#actual-fps").html(parseInt(tps));
		PSslow++;
		if (PSslow==20)		PSslow=0;
	}
	OldTime=d.getTime();

	if (PSactualTime>PStotalTime)
	{
		PSactualTime=PStotalTime;
		ps_stopAnim();
	}
	ps_posiTimeLine();
	ps_getEffects(PSroot,0);
}

// tout refaire
function ps_getEffects(ouid,euid)
{
	var object=_O(ouid);
	if (object.type<2&&object.firstchild)		ps_getEffects(object.firstchild,euid);
	if (object.next)							ps_getEffects(object.next,euid);
	if (euid&&_O(euid).parent==ouid)		effect=_O(euid);
	else
	{
		var effect = object.actualeffect;		// effet temporaire
		effect.parent=ouid;
		effect.time=PSactualTime;
	}
	tbl=object.effecttbl;
	// on fixe les valeurs par défaut
	ps_resetTbl(object.uid);
	// time à trouver 
	tbl.time=effect.time;
	// on boucle sur les effets
	start=object.firsteffect;
	while (start)
	{
		actef=_O(start);
		tbl.flag=tbl.flag|actef.flag;
		ps_setTbl(actef,tbl);
		start=actef.next;
	}
	// on recopie les valeurs
	ps_copyValues(tbl,effect);
	// modif des fenêtres*/
	ps_modifyPreviewObject(object.uid,effect,tbl.flag|EFFECT_WIDTH);
}
// changer la table en fonction de l'effet
function ps_setTbl(effect,tbl)
// effet : effet examiné
// tbl la table des effets
{
	if (effect.flag&EFFECT_RESET)		set_tblElementTog(effect.reset,tbl.reset,effect.time,tbl.time,0);
	if (effect.flag&EFFECT_X)			set_tblElement(effect.x,tbl.x,effect.time,tbl.time,0,effect.reset);
	if (effect.flag&EFFECT_Y)			set_tblElement(effect.y,tbl.y,effect.time,tbl.time,0,effect.reset);
	if (effect.flag&EFFECT_WIDTH)		set_tblElement(effect.width,tbl.width,effect.time,tbl.time,false,effect.reset);
	if (effect.flag&EFFECT_HEIGHT)		set_tblElement(effect.height,tbl.height,effect.time,tbl.time,false,effect.reset);
	if (effect.flag&EFFECT_ZOOM)		set_tblElement(effect.zoom,tbl.zoom,effect.time,tbl.time,1,effect.reset);
	if (effect.flag&EFFECT_ROTATE)		set_tblElement(effect.rotate,tbl.rotate,effect.time,tbl.time,0,effect.reset);
	if (effect.flag&EFFECT_OPACITY)	set_tblElement(effect.opacity,tbl.opacity,effect.time,tbl.time,1,effect.reset);
	if (effect.flag&EFFECT_BW)			set_tblElement(effect.bw,tbl.bw,effect.time,tbl.time,0,effect.reset);
	if (effect.flag&EFFECT_BLUR)		set_tblElement(effect.blur,tbl.blur,effect.time,tbl.time,0,effect.reset);
	if (effect.flag&EFFECT_SEPIA)		set_tblElement(effect.sepia,tbl.sepia,effect.time,tbl.time,0,effect.reset);
	if (effect.flag&EFFECT_BRIGHT)		set_tblElement(effect.bright,tbl.bright,effect.time,tbl.time,1,effect.reset);
	if (effect.flag&EFFECT_SATURATE)	set_tblElement(effect.saturate,tbl.saturate,effect.time,tbl.time,1,effect.reset);
	if (effect.flag&EFFECT_SHOW)		set_tblElementTog(effect.show,tbl.show,effect.time,tbl.time,0);
	if (effect.flag&EFFECT_FLIPX)		set_tblElementTog(effect.flipx,tbl.flipx,effect.time,tbl.time,0);
	if (effect.flag&EFFECT_FLIPY)		set_tblElementTog(effect.flipy,tbl.flipy,effect.time,tbl.time,0);
	if (effect.flag&EFFECT_MBLUR)		set_tblElementTog(effect.mblur,tbl.mblur,effect.time,tbl.time,0);
}
function set_tblElement(value,elem,time,search,def,reset)
// valeur de l'effet
// élément à changer de la table
// temps de l'effet
// temps à trouver
// valeur par défaut
{
	if (reset)
	{
		set_tblElementTog(value,elem,time,search,def);
		return;
	}
	if (elem.value!==false)	return;		//déjà fait
	if (time==search)
	{
		elem.value=value;
		return;
	}
	if (time<search)
	{
		elem.time1=time;
		elem.val1=value;
		return;
	}
	// time > search
	if (elem.val1===false)
	{
		elem.val1=def;
		elem.time1=0;
	}
	// time : temps fin
	// value : valeur fin
	// time1 : temps début
	// val1 : valeur début
	pc=(search-elem.time1)/(time-elem.time1);
	elem.value=elem.val1+(value-elem.val1)*pc;
}
function set_tblElementTog(value,elem,time,search,def)
// valeur de l'effet
// élément à changer de la table
// temps de l'effet
// temps à trouver
// valeur par défaut
{
	if (elem.value!==false)	return;		//déjà fait
	if (time==search)
	{
		elem.value=value;
		return;
	}
	if (time<search)
	{
		elem.time1=time;
		elem.val1=value;
		return;
	}
	// time > search
	if (elem.val1===false)
	{
		elem.val1=def;
		elem.time1=0;
	}
	elem.value=elem.val1;
}
// copie de tbl vers effect
function ps_copyValues(tbl,effect)
{
	// reset ?
	effect.reset=ps_copyIt(tbl.reset,0);
	// positions
	effect.x=ps_copyIt(tbl.x,0);
	effect.y=ps_copyIt(tbl.y,0);
	// tailles !
	effect.width=ps_copyIt(tbl.width,false);
	effect.height=ps_copyIt(tbl.height,false);
	// effets
	effect.zoom=ps_copyIt(tbl.zoom,1);
	effect.rotate=ps_copyIt(tbl.rotate,0);
	effect.opacity=ps_copyIt(tbl.opacity,1);
	effect.bw=ps_copyIt(tbl.bw,0);
	effect.blur=ps_copyIt(tbl.blur,0);
	effect.sepia=ps_copyIt(tbl.sepia,0);
	effect.bright=ps_copyIt(tbl.bright,1);
	effect.saturate=ps_copyIt(tbl.saturate,1);
	// Toggle
	effect.show=ps_copyIt(tbl.show,0);
	effect.flipx=ps_copyIt(tbl.flipx,0);
	effect.flipy=ps_copyIt(tbl.flipy,0);
	effect.mblur=ps_copyIt(tbl.mblur,0);
}
function ps_copyIt(elem,def)
{
	if (elem.value!==false)		return elem.value;
	if (elem.val1!==false)		return elem.val1;
	return def;
}

// uid de l'objet parent
function ps_resetTbl(uid)
{
	tbl=_O(uid).effecttbl;
	tbl.time=false;
	tbl.flag=0;
	ps_resetValues(tbl.x);
	ps_resetValues(tbl.y);
	ps_resetValues(tbl.width);
	ps_resetValues(tbl.height);
	ps_resetValues(tbl.zoom);
	ps_resetValues(tbl.rotate);
	ps_resetValues(tbl.opacity);
	ps_resetValues(tbl.bw);
	ps_resetValues(tbl.blur);
	ps_resetValues(tbl.sepia);
	ps_resetValues(tbl.bright);
	ps_resetValues(tbl.saturate);
	ps_resetValues(tbl.show);
	ps_resetValues(tbl.reset);
	ps_resetValues(tbl.flipx);
	ps_resetValues(tbl.flipy);
	if (tbl.mblur==undefined)	tbl.mblur=new PSinterval();
	ps_resetValues(tbl.mblur);
}
function ps_resetValues(eff)
{
	eff.time1=false;
	eff.val1=false;
	eff.value=false;
}
/* Rendering */
function ps_renderPhoto()
{
	if (PSdemo)
	{
		ps_isdemo(_translate("Réaliser un instantané"));
		return;
	}
	/* on fait l'anim */
	PSanimTime=PSactualTime;
	ps_posiTimeLine();
	ps_getEffects(PSroot,0);
	ps_Msg(_translate("Photographie..."));
	var anim=JSON.stringify(PSobjChain);
	$("#server").css("background-image","url('data/adm/ctcok.svg')");
	$.post("render.php",{cmd: "photo",data: anim,debug:false,method:0}, function (data) {
		// afficher le retour
		//console.log(data);
		retour=_parse(data);
		ps_Msg(retour[1]);
		if (retour[0]==0)
		{
			$("#view-photo").show();
			// changer la source pour rafraichissement
			var unique=new Date();
			$("#view-photo a").attr("href","projects/"+PSproject+"/"+PSscene+"/"+PSscene+".jpg?unique="+unique.getTime());
		}
	       else					$("#view-photo").hide();
		$("#server").css("background-image","url('data/adm/ctcoff.svg')");
	});
}
/* render animation */
function ps_renderFilm()
{
	an_open();
	$("#server").prependTo("#anim-div");
}
function ps_animStart()
{
	if (PSdemo)
	{
		ps_isdemo(_translate("Création de l'animation"));
		return;
	}
	PSFrame=0;		// pour nom de la frame
	PSactualTime=PSanimTime=an_imstart;
	ps_posiTimeLine();
	ps_getEffects(PSroot,0);
	// effacement de la table
	var html=an_tablerun();
	$("#an-table").html(html);
	// préparation de l'anim
	var anim=JSON.stringify(PSobjChain);
	$("#server").css("background-image","url('data/adm/ctcok.svg')");
	$.post("render.php",{cmd: "prepanim",data: anim,debug:an_imdebug,method:an_imethod,keep:an_imkeep}, function (data) {
		$("#server").css("background-image","url('data/adm/ctcoff.svg')");
		var reponse=_parse(data);
		printconsole(reponse);
		if (reponse[0]!=2)	ps_animNext();
	       else					an_cancel();
	});
}
function ps_animNext()
{
	an_setvalues(PSFrame);
	/* on fait l'anim */
	ps_posiTimeLine();
	ps_getEffects(PSroot,0);
	var anim=JSON.stringify(PSobjChain);
	$("#server").css("background-image","url('data/adm/ctcok.svg')");
	$.post("render.php",{cmd: "anim",data: anim,frame: PSFrame}, function (data) {
		// afficher la frame
		var reponse=_parse(data);
		printconsole(reponse);
		$("#server").css("background-image","url('data/adm/ctcoff.svg')");
		if (!an_imcancel && reponse[0]==0)
		{
			PSFrame++;
			PSanimTime=an_imstart+(PSFrame/_O(0).framerate);
			PSactualTime=PSanimTime;
			if (PSanimTime<=an_imstop)		ps_animNext();
			else	
			{
				printconsole("Création du film...",0,true);
				var anim=JSON.stringify(PSobjChain);
				$("#server").css("background-image","url('data/adm/ctcok.svg')");
				$.post("render.php",{cmd: "finalize",data:anim,sound:an_addsound}, function (data) {
					$("#server").css("background-image","url('data/adm/ctcoff.svg')");
					var reponse=_parse(data);
					printconsole(reponse);
					an_setresult(PSproject,PSscene);
					printconsole(_translate("Fin du rendu"),0,true);
					printconsole(_translate("Fermeture de la console"));
					an_cancel();
				});
			}
		}
		else			printconsole(_translate("Annulation du rendu"),2);
	});
}
/* variables d'animation */
var an_imstart=0;
var an_imstop=0;
var an_imkeep=0;
var an_imdebug=0;
var an_imethod=1;
var an_imcancel=0;
var an_imstartime=0;
var an_imlasttime=0;
var an_crf=0;
var an_addsound=1;
/* table anim run */
function an_setvalues(frame)
{
	// images
	frame++;
	var duree=Math.round((an_imstop-an_imstart)*10)/10;
	var fin=parseFloat(an_imstop).toFixed(2);
	var nbframe=Math.round(duree*_O(0).framerate)+1;
	//console.log(an_imstop+" "+an_imstart+" "+_O(0).framerate+" "+total);
	var position=Math.floor((frame-1)*100/_O(0).framerate)/100+an_imstart;
	if (frame>nbframe)	return;
	$("#an-progress").attr("max",nbframe);
	$("#an-progress").attr("value",frame);
	$("#an-frame").html("("+frame+"/"+nbframe+")");
	$("#an-position").html(position.toFixed(2)+"/"+fin+"s");
	// temps
	var d=new Date();
	var time=d.getTime();
	if (an_imstartime==0)
	{
		an_imstartime=time;
		an_imlasttime=0;
	}
	// total temps
	var ttime=time-an_imstartime;
	// durée moyenne
	var taverage=ttime/frame;
	// estimation
	var tprev=taverage*(nbframe-frame);
	// dernier rendu
	var tlast="--";
	if (an_imlasttime)	tlast=_translate("Dernière image")+" : "+an_visual(time-an_imlasttime,1);
	// afficher
	//$("#an-statistique").html("Temps total : "+an_visual(ttime)+" Moyenne : "+an_visual(taverage,1)+" Reste : "+an_visual(tprev));
	$("#an-statistique1").html(_translate("Temps total")+" : "+an_visual(ttime));
	$("#an-statistique2").html(_translate("Reste")+" : "+an_visual(tprev));
	$("#an-statistique3").html(_translate("Moyenne")+" : "+an_visual(taverage,1));
	$("#an-statistique4").html(tlast);
	// archives
	an_imlasttime=time;
}
function an_visual(time,decim)
{
	// calculer en secondes
	if (decim)	timer=Math.round(time/10)/100;
	else			timer=Math.round(time/1000);
	if (timer<60)		return timer+"s";
	var d=new Date();
	d.setTime(time);
	// retour
	var hours=d.getHours();
	var minutes=d.getMinutes();
	var secondes=d.getSeconds();
	var h=false;
	if (timer>=3600)	h=true;
	var retour="";
	if (h)	retour+=hours+"h ";
	retour+=minutes+"m "+secondes+"s";
	return retour;
}
function an_setresult(user,project)
{
	var dir="projects/"+user+"/"+project+"/"+project;
	switch (an_imethod)
	{
		case 0:
			$("#an-result1").html("<a href='"+dir+".mp4' target='_blank'>"+_translate("Voir l'animation")+"</a>");
			$("#an-result2").html("<a href='"+dir+".mp4' download=''>"+_translate("Télécharger")+"</a>");
			break;
		case 1:
				$("#an-prepanim").html(_translate("Calculs envoyés au serveur !"));
			break;
		case 2:
			$("#an-result1").html(_translate("Télécharger le script :"));
			if (ps_windows)		$("#an-result2").html("<a href='"+dir+".bat' download=''>BAT file</a>");
			else					$("#an-result2").html("<a href='"+dir+".linux' download=''>GNU/Linux script</a>");
			break;
		default:
			break;
	}
}
function an_tablerun()
{
	var zero=_O(0);
	var html="";
	if (an_imethod==1)	html+="<h1 id='an-prepanim'>"+_translate("Préparation de l'animation")+"</h1>";
	else								html+="<h1>"+_translate("En cours...")+"</h1>";

	html+="<tr>";
	// titre
	html+="<td colspan=2 style='text-align:center;color:white'>"+_O(PSroot).name+"</td>";
	// rappel
	html+="</tr><tr>";
	html+="<td>"+_translate("Format")+" "+an_explicitformat(zero.factorx,zero.factory)+"</td>";
	html+="<td>("+x_corrector(zero.resolution*zero.factorx/zero.factory)+"/"+zero.resolution+")</td>";
	html+="</tr><tr>";
	html+="<td colspan=2>"+_translate("Résolution")+" : "+zero.resolution;
	html+="p "+_translate("Images/seconde")+" : "+zero.framerate;
	html+=" "+_translate("Canvas")+" : x"+zero.canvas+"</td>";
	// message run
	html+="</tr><tr>";
	html+="<td id='an-runmsg' colspan=2><td>";
	// barre de progression
	html+="</tr><tr>";
	html+="<td colspan=2 style='text-align:center;color:white'>"+_translate("Animation")+"<td>";
	html+="</tr><tr>";
	html+="<td style='width:50%'><progress id='an-progress' value=0 max=1></progress></td><td style='width:50%' id='an-frame'>(/)</td>";
	// Réalisé
	html+="</tr><tr>";
	html+="<td>Position&nbsp;:</td><td id='an-position'>0s/0s</td>";
	// temps
	html+="</tr><tr>";
	html+="<td colspan=2 style='text-align:center;color:white'>Rendu<td>";
	html+="</tr><tr>";
	html+="<td id='an-statistique1'></td><td id='an-statistique2'></td>";
	html+="</tr><tr>";
	html+="<td id='an-statistique3'></td><td id='an-statistique4'></td>";
	// résultat du rendu
	html+="</tr><tr>";
	html+="<td id='an-result1'></td><td id='an-result2'></td>";
	// annulation rendu / fermer
	html+="</tr><tr>";
	html+="<td></td><td id='an-button'><span class='button' style='color:red' onclick='an_cancel();'>"+_translate("Arrêter le rendu")+"</span></td>";
	html+="</tr>"
	an_imstartime=0;
	return html;
}
/* fenêtre de préparation anim */
function an_open()
{
	var checked;
	an_imcancel=0;
	var zero=_O(0);
	// pos et taille de la fenêtre settings
	var left=$('#div-preview').width()+20;
	var height=$('#div-preview').height()+20;
	var html="";
	html+="<div id='anim-div' style='z-index:800;left:"+left+"px;height:"+height+"px;'>";
	html+="<table id='an-table'><tr>";
		// titre
	html+="<td colspan=3>"+_translate("Rendu")+"&nbsp;:&nbsp;"+_O(PSroot).name+"</td>";
	html+="</tr><tr>";
		// résolution et format
	html+="<td colspan=2>"+_translate("Format")+" "+an_explicitformat(zero.factorx,zero.factory)+"</td>";
	html+="<td id='an-dimension'>("+x_corrector(zero.resolution*zero.factorx/zero.factory)+"/"+zero.resolution+")</td>"
	html+="</tr><tr>";
	html+="<td>"+_translate("Résolution")+"&nbsp;:</td>";
	html+="<td><input id='an-rangereso' type='range' value="+find_index([240,360,480,540,720,1080,1440,2160],zero.resolution)+" min=0 max=7 step=1 oninput='an_chgreso();'></td><td id='an-reso'></td>";
	html+="</tr><tr>";
		// framerate
	html+="<td>"+_translate("Image / seconde")+"&nbsp;:</td><td><input id='an-rangefps' type='range' value="+find_index([10,30,60],zero.framerate)+" min=0 max=2 step=1 oninput='an_chgfps();'></td><td id='an-fps'></td>";
		// canvas
	html+="</tr><tr>";
	html+="<td>"+_translate("Canvas")+"&nbsp;:</td><td><input id='an-rangecanvas' type='range' value="+find_index([1,2,4,5,8],zero.canvas)+" min=0 max=4 step=1 oninput='an_chgcanvas();'></td><td id='an-canvas'></td>";
		// motion blur
	//html+="</tr><tr style='display:none'>";
	//html+="<td style='font-style:italic;'>Flou mvt*&nbsp;:</td><td><input id='an-rangeblur' type='range' value="+zero.motionblur+" min=0 max=50 step=1 oninput='an_chgblur();'></td><td id='an-blur'>"+zero.motionblur+"px</td>";
	// qualité
	an_crf=zero.crf-17;
	html+="<tr><td>"+_translate("Qualité")+"&nbsp;:</td><td><input id='an-rangecrf' type='range' value='"+an_crf+"' min=0 max=10 step=1 oninput='an_chgcrf();'></td><td id='an-crf'>"+an_convertcrf()+"</td></tr>";
	// son
	if (_O(0).snd)
	{
		if (an_addsound)	checked="checked";
		else							checked="";
		html+="<tr><td colspan=3><input type='checkbox' onchange='an_sound();' id='an-sound' "+checked+">"+_translate("Intégrer le son")+"</td></tr>";
	}
	else	an_addsound=0;
	// longueur du projet
	html+="<tr><td><input type='checkbox' onchange='an_full();' id='an-full' checked>"+_translate("Entier")+"</td><td id='an-frames'></td><td id='an-duree'></tr>";
	html+="<tr id='an-trstart'>";
	html+="<td>"+_translate("Début")+"&nbsp;:</td><td><input id='an-rangestart' type='range' value=0 min=0 max="+(parseFloat(zero.length)-0.1)+" step=0.1 oninput='an_chgstartend();'></td><td id='an-start'>0s</td>";
	html+="</tr><tr id='an-trend'>";
	html+="<td>"+_translate("Fin")+"&nbsp;:</td><td><input id='an-rangeend' type='range' value="+zero.length+" min=.1 max="+zero.length+" step=0.1 oninput='an_chgstartend();'></td><td id='an-end'>"+zero.length+"s</td>";
	// Keep files && debug
	html+="</tr>";
	if (PSflags&64)
	{
		html+="<tr>";
		if (an_imkeep)	checked="checked";
		else				checked="";
		html+="<td colspan=3><input type='checkbox' onchange='an_keep();' id='an-keep' "+checked+">"+_translate("Conserver les images de travail sur le serveur")+".</td>";
		html+="</tr><tr>";
		if (an_imdebug)	checked="checked";
		else				checked="";
		html+="<td colspan=3><input type='checkbox' onchange='an_debug();' id='an-debug' "+checked+">"+_translate("Activer les informations de débogage.")+"</td>";
		html+="</tr><tr>";
		// method
		html+="<td colspan='3'>"+_translate("Méthode de rendu")+"&nbsp;:&nbsp;";
		html+="<select id='an-method' onchange='an_method();'>"+an_addoptions(an_metab,an_imethod)+"</select></td>";
		html+="</tr>";
	}
	html+="<tr>";
	html+="<td></td><td><span class='button' onclick='ps_animStart()'>"+_translate("Création de l'animation")+"</span></td>";
	html+="<td><span class='button' onclick='an_close();'>"+_translate("Annuler")+"</span></td>";
	html+="</tr></table>";
	// Boutons
	html+="</div>";
	var dheight=$(window).height()-height-2;
	html+="<div id='debug-div' style='top:"+height+"px;height:"+dheight+"px;'></div>";
	//ouvrir
	$("#popuplock").html(html);
	$("#popuplock").css("background-color","rgba(0,0,0,0)");
	if (an_imdebug)		$("#debug-div").show();
	else					$("#debug-div").hide();
	$("#popuplock").show();
	an_chgreso(zero.resolution);
	an_chgfps(zero.framerate);
	an_full();
	printconsole(_translate("Ouverture de la console"),0);
}
/* son */
//if (an_addsound)	checked="checked";
//else							checked="";
//html+="<tr><td colspan=3><input type='checkbox' onchange='an_sound();' id='an-sound' "+checked+">"+_translate("Intégrer le son")+"</td></tr>";
function an_sound()
{
		if ($("#an-sound").prop("checked"))	an_addsound=1;
		else															an_addsound=0;
}

/* méthode de rendu */
var an_metab=["Direct","File attente","Script"];
function an_method()
{
	an_imethod=an_metab.indexOf($("#an-method option:selected").val());	//parseFloat($("#an-method option:selected").val().substr(0,1))-1;
}
/* gestion des flags */
function an_keep()
{
	an_imkeep=$("#an-keep").prop("checked");
	if (!an_imkeep)	an_imkeep=0;
	else				an_imkeep=1;
}
function an_debug()
{
	an_imdebug=$("#an-debug").prop("checked");
	if (!an_imdebug)		an_imdebug=0;
	else					an_imdebug=1;
	if (an_imdebug)	$("#debug-div").show();
	else				$("#debug-div").hide();
}
/* gestion durée animation */
function an_full()
{
	var full=$("#an-full").prop("checked");
	if (full)
	{
		var duree=_O(0).length;
		var nbframe=duree*_O(0).framerate+1;
		an_imstart=0;
		an_imstop=duree;
		$("#an-trstart").hide();
		$("#an-trend").hide();
		$("#an-duree").html(_translate("Durée : ")+duree+"s");
		$("#an-frames").html(nbframe+" "+_translate("images"));
	}
	else
	{
		$("#an-trstart").show();
		$("#an-trend").show();
		an_interval(0,_O(0).length);
	}
}
function an_chgstartend()
{
		var start=$("#an-rangestart").val();
		var end=$("#an-rangeend").val();
		an_interval(start,end);
}
function an_interval(start,end)
{
		start=parseFloat(start);
		end=parseFloat(end);
		// correction des erreurs
		if (start>=end)	end=(start+0.1);
		// set
		an_imstart=start;
		an_imstop=end;
		$("#an-rangestart").val(start);
		$("#an-rangeend").val(end);
		var duree=Math.round((end-start)*10)/10;
		var nbframe=Math.round(duree*_O(0).framerate)+1;
		$("#an-duree").html(_translate("Durée : ")+duree+"s");
		$("#an-frames").html(nbframe+" "+_translate("images"));
		$("#an-start").html(start+"s");
		$("#an-end").html(end+"s");

}
/* gestion de la résolution */
function an_chgreso(value)
{
	if (!value)
	{
		value=an_explicitreso($("#an-rangereso").val());
		_O(0).resolution=value;
	}
	var ajout="";
	if (value==720)	ajout=" HDTV";
	else if (value==1080)	ajout=" Full HD";
	else if (value==2160)	ajout=" 4K";
	$("#an-reso").html(value+"p"+ajout);
	$("#an-dimension").html("("+x_corrector(_O(0).resolution*_O(0).factorx/_O(0).factory)+"/"+_O(0).resolution+")");
	var msg = " ("+(x_corrector(_O(0).resolution*_O(0).factorx/_O(0).factory)*_O(0).canvas)+"/"+_O(0).resolution*_O(0).canvas+")";
	$("#an-canvas").html("x"+_O(0).canvas+msg);
}
function an_explicitformat(fx,fy)
{
	if (fx==16&&fy==9)		return "16:9";
	if (fx==4&&fy==3)		return "4:3";
	if (fx==fy)				return _translate("Carré");
	if (fx==9&&fy==16)		return _translate("Portrait");
	if (fx==2.35&&fy==1)	return _translate("Cinéma");
	return "16:9";
}
function an_explicitreso(num)
{
	var reso=Array(240,360,480,540,720,1080,1440,2160);
	return reso[num];
}
/* gestion du fps */
function an_chgfps(value)
{
	if (!value)
	{
		value=an_explicitfps($("#an-rangefps").val());
		_O(0).framerate=value;
	}
	$("#an-fps").html(value+"/s");
	an_interval(an_imstart,an_imstop);
}
function an_explicitfps(num)
{
	var fps=Array(10,30,60);
	return fps[num];
}
/* gestion du canvas */
function an_chgcanvas(value)
{
	if (!value)
	{
		value=an_explicitcanvas($("#an-rangecanvas").val());
		_O(0).canvas=value;
	}
	var msg = " ("+x_corrector(_O(0).resolution*_O(0).factorx*_O(0).canvas/_O(0).factory)+"/"+_O(0).resolution*_O(0).canvas+")";
	$("#an-canvas").html("x"+value+msg);
}
function an_explicitcanvas(num)
{
	var ca=Array(1,2,4,5,8);
	return ca[num];
}
/* gestion du flou */
function an_chgblur(value)
{
	value=$("#an-rangeblur").val();
	_O(0).motionblur=value;
	$("#an-blur").html(value+"px");
}
/* qualité */
function an_chgcrf(value)
{
	value=$("#an-rangecrf").val();
	_O(0).crf=parseInt(value,10)+17;
	$("#an-crf").html(an_convertcrf());
}
function an_convertcrf()
{
	var value=_O(0).crf-17; //(de 0 à 10)
	if (value<3)	return _translate("Haute");
	if (value>6)	return _translate("Basse");
	return _translate("Moyenne");
}
/* ajouter des option */
function an_addoptions(liste,selection)
{
	// FLDIRECT=64
	var retour="";
	// lister les méthodes du serveur
	var idx=0;
	if (PSflags&64)
	{
		while (PSmethod[idx]!=undefined)
		{
			if (PSmethod[idx]==selection)	retour+="<option selected>"+liste[PSmethod[idx]];
			else					retour+="<option>"+liste[PSmethod[idx]];
			idx++;
		}
	}
	else
	{
		retour+="<option selected>"+liste[1];
	}
	return retour;
}
/* retourner index */
function find_index(tbl,value)
{
	var idx=0;
	while (tbl[idx]!=undefined && value!=tbl[idx])	idx++;
	if (tbl[idx]==undefined)	return 0;
	return idx;
}
/* correction résolution x */
function x_corrector(fx)
{
	fx=Math.floor(fx/2);
	fx=fx*2;
	return fx;
}
/* date time */
function printconsole (message,level,force)
{
	if (force)	$("#an-runmsg").html("<span style='color:blue;'>"+message+"</span>");
	if ($.isArray(message))
	{
		var idx=0;
		while (message[idx]!=undefined)
		{
			if (message[idx+1])	printconsole(message[idx+1],message[idx]);
			idx+=2;
		}
		return;
	}
	var date = new Date();
	var style="";
	if (level)	style+=" style='color:";
	else			message="I: "+message;
	if (level==1)
	{
		style+="orange;'";
		message="W: "+message;
	}
	else if (level==2)
	{
		style+="red;'";
		$("#an-runmsg").html("<span style='color:red;'>"+message+"</span>");
		message="E: "+message;
	}
	var retour="<span"+style+">";
	retour+=date.getDate()+"/"+ date.getMonth() +"/"+ date.getFullYear()+" ";
	retour+=date.getHours()+":"+hformat(date.getMinutes())+":"+hformat(date.getSeconds())+"> ";
	retour+=message+"</span><br>";
	if (an_imdebug)		scrolldiv("debug-div",retour);
}
function scrolldiv(id,message)
{
	var objDiv = document.getElementById(id);
	var doScroll=objDiv.scrollTop>=(objDiv.scrollHeight-objDiv.clientHeight);                   
	// add new msg
	$('#' + id ).append(message);
	// scroll si fin de page affichée
	if( doScroll) objDiv.scrollTop = objDiv.scrollHeight;
}

function hformat(data)
{
	if (data<10)		return "0"+data;
	else				return data;
}
/* fermer la fenêtre et abandon */
function an_cancel()
{
	an_imcancel=1;
	$("#an-button").html("<span class='button' onclick='an_close();'>"+_translate("Fermer")+"</span>");
}
function an_close()
{
	$("#server").insertBefore("#sysmsg");
	ps_cancel();
}
/* fonction parse sécurisée */
function _parse(string)
{
	try {
	return	JSON.parse(string);
	} catch (e) {
	console.log(e.message);
	console.log(string);
	alert("Internal error : "+string);
	return false;
	}
}




