/* JS Les effets spéciaux */
var TopEffet=68;
/*-------- Effects ------------------------*/
function ps_addEffect(uid,time)
{
	if (!time)	time=PSactualTime;
	// PSselected (uid de l'élément sélectionné)
	// PSactualTime (position actuelle du curseur) ou time
	if (!PSselected)	return;
	PSChg++;
	// recherche de la place de l'effet dans la ligne
	var effectuid=_O(PSselected).firsteffect;
	// si pas de suivant ou suivant > on s'arrête
	while (_O(effectuid).next&&_O(_O(effectuid).next).time<=time)	effectuid=_O(effectuid).next;
	// si égalité, pas de création d'un nouvel effet
	if (!uid && _O(effectuid).time==time)	return;
	// création d'une nouvelle struct si pas d'uid
	if (!uid)
	{
		var effect=new PSeffect(0,PSselected);
		PSobjChain[effect.uid]=effect;
		effect.time=time;
	}
	else
	{
		var effect=_O(uid);
	}
	// insert dans la chaîne
	effect.next=_O(effectuid).next;
	effect.prev=effectuid;
	_O(effectuid).next=effect.uid;
	if (effect.next)	_O(effect.next).prev=effect.uid;
	// effacement de la sélection
	var tmp=PSselected;
	ps_selectObject(0);
	ps_selectObject(tmp);
}
/* déplacer un effet */
function PS_moveEffect(uid,time)
{
	// rectif valeur de time
	time=Math.floor(time*10)/10;
	if (time<=0)						return;	//erreur
	PSChg++;
	if (time>PStotalTime)			time=PStotalTime;
	effect=_O(uid);
	if (effect.time==time)	return;		// nop
	// On détache l'effet, normalement impossible que prev soit null !
	_O(effect.prev).next=effect.next;
	if (effect.next)	_O(effect.next).prev=effect.prev;
	effect.prev=null;
	effect.next=null;
	// on insert au bon endroit
	effect.time=time;
	ps_addEffect(uid,time);
	// on retranscrit à l'écran
	PSactualTime=time;
	ps_posiTimeLine();
	ps_getEffects(PSroot,0);
}
/* click sur un effet */
function ps_clickEffect(uid)
{
	if (PSactualTime!=_O(uid).time)
	{
		PSactualTime=_O(uid).time;
		ps_posiTimeLine();
	}
	ps_openEffect(uid);
}
/* close */
function ps_closeEffect()
{
	if (!PSedEffect)	return;
	$("#div-neweffect").hide();
	$("#ef-bar").hide();
	$("#div-neweffect").html("");
	$("#div-right").height(RightH);
	PSedEffect=0;
	eff_showEffect(false);
}
/* delete */
function ps_deleteEffect(uid)
{
	if (!uid)	uid=PSedEffect;
	if (!uid)	return;
	effect=_O(uid);
	if (!effect.prev)	return;				// on ne peut supprimer le premier
	_O(effect.prev).next=effect.next;
	if (effect.next)	_O(effect.next).prev=effect.prev;
	PSobjChain[uid]=null;
	// effacement de la sélection
	tmp=PSselected;
	ps_selectObject(0);
	ps_selectObject(tmp);
	ps_getEffects(PSroot,0);
}
/* undo */
function ps_undoEffect()
{
	// remettre les valeurs de départ
	var uid=PSedEffect;
	var effect=_O(uid);
	var undo=PSUndo;
	effect.flag=undo.flag;
	effect.time=undo.time;
	effect.x=undo.x;
	effect.y=undo.y;
	effect.reset=undo.reset;
	effect.width=undo.width;
	effect.height=undo.height;
	effect.zoom=undo.zoom;
	effect.rotate=undo.rotate;
	effect.opacity=undo.opacity;
	effect.show=undo.show;
	effect.flipx=undo.flipy;
	effect.bw=undo.bw;
	effect.blur=undo.blur;
	effect.sepia=undo.sepia;
	effect.bright=undo.bright;
	effect.saturate=undo.saturate;
	effect.mblur=undo.mblur;
	ps_openEffect(uid);
}
var PSlockEffect=true;
/*lock unlock */
function ef_lockEffect()
{
	if (PSlockEffect)
	{
		PSlockEffect=false;
		$("#ef-lock").css("background-image","url('data/newicons/ef_unlock.svg')");
	}
	else
	{
		PSlockEffect=true;
		$("#ef-lock").css("background-image","url('data/newicons/ef_lock.svg')");
	}
}

/*--- composition de la fenêtre d'effet ------ */
function ps_openEffect(uid)
{
	PSedEffect=uid;
	var effect=_O(uid);
	ps_getEffects(PSroot,uid);
	// copier valeurs
	//function (time, uid, reset, x, y, width, height, zoom, rotate, opacity, show, flipx, flipy, bw, blur, sepia, bright, saturate, mblur)
	PSUndo = new PSUndoEffect(effect.flag, effect.time, effect.uid, effect.reset, effect.x, effect.y, effect.width, effect.height, effect.zoom, effect.rotate, effect.opacity, effect.show, effect.flipx, effect.flipy, effect.bw, effect.blur, effect.sepia, effect.bright, effect.saturate, effect.mblur);

	// construire fenêtre
	var html="";
	html+="<div class='nef_block'>";
	html+=ps_addnew(effect,EFFECT_SHOW,WID_CHECK,_translate("Cacher"),effect.show);
	html+=ps_addnew(effect,EFFECT_RESET,WID_CHECK,_translate("Réinitialiser"),effect.reset);
	html+="</div>";
	
	html+=ps_addnew(effect,EFFECT_X,WID_INFO,"X",effect.x);
	html+=ps_addnew(effect,EFFECT_Y,WID_INFO,"Y",effect.y);

	html+=ps_addnew(effect,EFFECT_WIDTH,WID_CURSOR,_translate("Largeur"),effect.width,0,100,100);
	html+=ps_addnew(effect,EFFECT_HEIGHT,WID_CURSOR,_translate("Hauteur"),effect.height,0,100,100);
	html+="<hr>";
	if (_O(effect.parent).type==2)
	{
		html+="<div class='nef_block'>";
		html+=ps_addnew(effect,EFFECT_FLIPX,WID_CHECK,_translate("Inverser"),effect.flipx);
		html+=ps_addnew(effect,EFFECT_FLIPY,WID_CHECK,_translate("Retourner"),effect.flipy);
		html+="</div>";

		html+=ps_addnew(effect,EFFECT_ROTATE,WID_CURSOR,_translate("Rotation"),effect.rotate,-100,100,0);
		html+="<hr>";
	}

	html+=ps_addnew(effect,EFFECT_ZOOM,WID_CURSOR,_translate("Zoom"),effect.zoom,0,400,100);

	html+=ps_addnew(effect,EFFECT_OPACITY,WID_CURSOR,_translate("Opacité"),effect.opacity,0,100,100);
	html+=ps_addnew(effect,EFFECT_BLUR,WID_CURSOR,_translate("Flou"),effect.blur,0,100,0);

	html+=ps_addnew(effect,EFFECT_BW,WID_CURSOR,_translate("Noir&Blanc"),effect.bw,0,100,0);
	html+=ps_addnew(effect,EFFECT_SEPIA,WID_CURSOR,_translate("Sépia"),effect.sepia,0,100,0);

	html+=ps_addnew(effect,EFFECT_BRIGHT,WID_CURSOR,_translate("Luminosité"),effect.bright,0,300,100);
	html+=ps_addnew(effect,EFFECT_SATURATE,WID_CURSOR,_translate("Saturation"),effect.saturate,0,300,100);

	// changer tailles fenêtres
	$("#div-neweffect").height(RightH-TopEffet-30);
	$("#div-right").height(TopEffet);
	// show
	$('#div-neweffect').html(html);
	$("#ef-bar").html(ef_getbar(uid,effect));
	$("#ef-bar").show();
	$("#div-neweffect").show();
	// adapter le scroll
	var offset=$("#objline"+_O(uid).parent).offset();
	var offo=$("#objline1").offset();
	$("#div-right").scrollTop(offset.top-offo.top);

	eff_chgEffect(effect.parent);
}
// ajout input new mode
function ps_addnew(effect,flag,type,text,value,min,max,defvalue)
{
	if (min==undefined)	min=false;
	if (max==undefined) max=false;
	if (defvalue==undefined)	defvalue=0;
	/* effect activé ?*/
	var img="";
	var color="black";
	var style="";

	if (!(effect.flag&flag))
	{
		img="ef_grey.svg";
		color="#AAA";
		style="disabled style='opacity:.5;'";
	}
	else
	{
		if (type!=WID_CHECK)	img="ef_arrow.svg";
		else	
		{
			if (value)			img="ef_checked.svg";
			else				img="ef_unchecked.svg"
		}
	}
	// ajout widgets
	var html="";
	if (type!=WID_CHECK)	html+="<div class='nef_block'>";
		html+="<div style='color:"+color+";min-width:80px;text-align:right;margin-right:5px;' class='nef_divin' id='efi_div"+flag+"'>"+text+"</div>";
		html+="<div class='nef_divin'><img id='efimg"+flag+"' onclick='ef_clicktoggle("+flag+");' src='data/newicons/"+img+"'></div>";
	// switch
	switch (type)
	{
		case WID_INFO:
			html+="<div class='nef_divin'><input "+style+" id='ef-value"+flag+"' type='text' onchange='ps_chgvalue(event,"+flag+");' value='"+(value*100)+"'/>%</div></div>";
			break;
		case WID_CURSOR:
			if (value===false)	value=1;
			html+="<div class='nef_divin'>";
			html+="<input "+style+" id='ef-range"+flag+"' oninput='ef_range("+flag+");' onchange='ef_range("+flag+");' type='range' min='"+min+"' max='"+max+"' step='0.1' value='"+(value*100)+"'/></div>";
			html+="<div class='nef_divin'><input "+style+" id='ef-value"+flag+"' type='text' onchange='ps_chgvalue(event,"+flag+");' value='"+(value*100)+"'/>%</div>";
			html+="<div class='nef_divin'><img id='ef-reset"+flag+"' src='data/newicons/ef_reset.svg' onclick='ef_reset("+flag+","+defvalue+")'"+style+"></div></div>"
			break;
	}
	return html;
}

// afficher en %
function _pc(pc)
{
	return (Math.round(pc*1000)/10)+"%";
}
// barre d'info des effets
function ef_getbar(uid,effect)
{
	var html="<div class='nef_divin'>"+_O(effect.parent).name+"</div>";
	html+="<div id='ef-right'>";
	html+="<div id='ef-undo' onmousedown='ps_undoEffect();' ontouchstart='ps_undoEffect()'></div>";
	if (_O(uid).prev)	html+="<div id='ef-delete' onmousedown='psm_deleteObject(event,0)' ontouchstart='psm_deleteObject(event,0)'></div>"; 
	html+="<div id='ef-close' onmousedown='ps_closeEffect();' ontouchstart='ps_closeEffect()'></div>";
	html+="</div>";
	return html;
}
/* --------- Events effects ----------*/
// changer le flag
function ef_clicktoggle(flag)
{
	PSChg++;
	effect=_O(PSedEffect);
	switch (flag)
	{
		case EFFECT_X:
		case EFFECT_Y:
		case EFFECT_BW:
		case EFFECT_SEPIA:
		case EFFECT_BRIGHT:
		case EFFECT_SATURATE:
		case EFFECT_BLUR:
		case EFFECT_ROTATE:
		case EFFECT_ZOOM:
		case EFFECT_WIDTH:
		case EFFECT_HEIGHT:
		case EFFECT_OPACITY:
			ef_chgsimple(effect,flag);
			break;
		case EFFECT_SHOW:
			effect.show=ef_chgdouble(effect,EFFECT_SHOW,effect.show);
			break;
		case EFFECT_RESET:
			effect.reset=ef_chgdouble(effect,EFFECT_RESET,effect.reset);
			break;
		case EFFECT_FLIPX:
			effect.flipx=ef_chgdouble(effect,EFFECT_FLIPX,effect.flipx);
			break;
		case EFFECT_FLIPY:
			effect.flipy=ef_chgdouble(effect,EFFECT_FLIPY,effect.flipy);
			break;
		case EFFECT_MBLUR:
			effect.mblur=ef_chgdouble(effect,EFFECT_MBLUR,effect.mblur);
			break;
	}
	ps_getEffects(effect.parent,effect.uid);
	ps_modifyPreviewObject(effect.parent,effect,flag);
	eff_chgEffect(effect.parent);
	//ps_chgCanvas(effect.parent);
}
// changement de range
function ef_range(flag)
{
	var	effect=_O(PSedEffect);
	if (!(effect.flag&flag))	return;
	PSChg++;
	// position range a changé
	var value=$("#ef-range"+flag).val();
	$("#ef-value"+flag).val(value);
	value=value/100;
	switch (flag)
	{
		case EFFECT_WIDTH:
			effect.width=value;
			break;
		case EFFECT_HEIGHT:
			effect.height=value;
			break;
		case EFFECT_OPACITY:
			effect.opacity=value;
			break;	
		case EFFECT_BW:
			effect.bw=value;
			break;
		case EFFECT_SEPIA:
			effect.sepia=value;
			break;
		case EFFECT_BRIGHT:
			effect.bright=value;
			break;
		case EFFECT_SATURATE:
			effect.saturate=value;
			break;
		case EFFECT_BLUR:
			effect.blur=value;
			break;
		case EFFECT_ROTATE:
			effect.rotate=value;
			break;
		case EFFECT_ZOOM:
			effect.zoom=value;
			break;
	}
	ps_modifyPreviewObject(effect.parent,effect,flag);
	//ps_chgCanvas(effect.parent);
	eff_chgEffect(effect.parent);
}
// changement image
function ef_chgdouble(effect,flag,value)
{
	if (!(effect.flag&flag))
	{
		effect.flag+=flag;
		$("#efimg"+flag).attr("src","data/newicons/ef_unchecked.svg");
		$("#efi_div"+flag).css("color","black");
		return 0;
	}
	if (value)
	{
		effect.flag-=flag;
		$("#efimg"+flag).attr("src","data/newicons/ef_grey.svg");
		$("#efi_div"+flag).css("color","#AAA");
		return 1;
	}
	$("#efimg"+flag).attr("src","data/newicons/ef_checked.svg");
	return 1;
}
function ef_chgsimple(effect,flag)
{
	if (effect.flag&flag)
	{
		effect.flag-=flag;
		$("#efimg"+flag).attr("src","data/newicons/ef_grey.svg");
		$("#efi_div"+flag).css("color","#AAA");
		if ($("#ef-range"+flag).length)
		{
			$("#ef-range"+flag).prop("disabled",true);
			$("#ef-range"+flag).css("opacity",0.5);
			$("#ef-reset"+flag).css("opacity",0.5);
		}
		$("#ef-value"+flag).prop("disabled",true);
		$("#ef-value"+flag).css("opacity",0.5);
	}
	else
	{
		effect.flag+=flag;
		$("#efimg"+flag).attr("src","data/newicons/ef_arrow.svg");
		$("#efi_div"+flag).css("color","black");
		if ($("#ef-range"+flag).length)
		{
			$("#ef-range"+flag).prop("disabled",false);
			$("#ef-range"+flag).css("opacity",1);
			$("#ef-reset"+flag).css("opacity",1);
		}
		$("#ef-value"+flag).prop("disabled",false);
		$("#ef-value"+flag).css("opacity",1);
	}
}
// changement d'une valeur
function ps_chgvalue(event,flag)
{
	// valeur ?
	var value=$("#ef-value"+flag).val();
	value=parseFloat(ef_pointvirgule(value));
	if ($("#ef-range"+flag).length)
	{
		// contrôle de la valeur
		var min=$("#ef-range"+flag).attr("min");
		var max=$("#ef-range"+flag).attr("max");
		if (value<min)	value=min;
		if (value>max)	value=max;
		//console.log("Min : "+min+" Max : "+max+" "+value);
		$("#ef-range"+flag).val(value);
		ef_range(flag);
	}
	else
	{
		var effect=_O(PSedEffect);
		var uid=effect.parent;
		if (flag==EFFECT_X)		effect.x=value/100;
		if (flag==EFFECT_Y)		effect.y=value/100;
		ps_modifyPreviewObject(uid,effect,effect.flag&(EFFECT_X|EFFECT_Y));
		//ps_chgCanvas(uid,effect.zoom);
		eff_chgEffect(uid);
	}
}
// revenir à la valeur par défaut
function ef_reset(flag,value)
{
	if ($("#ef-reset"+flag).css("opacity")!=1)	return;
	// valeur ?
	if ($("#ef-range"+flag).length)
	{
		//console.log(value);
		$("#ef-range"+flag).val(value);
		ef_range(flag);
	}
/*	else
	{
		var effect=_O(PSedEffect);
		var uid=effect.parent;
		if (flag==EFFECT_X)		effect.x=value/100;
		if (flag==EFFECT_Y)		effect.y=value/100;
		ps_modifyPreviewObject(uid,effect,effect.flag&(EFFECT_X|EFFECT_Y));
		//ps_chgCanvas(uid,effect.zoom);
		eff_chgEffect(uid);
	}*/
}
/* étirer / rétrécir le temps */
function ps_distortime()
{
	var reqtime=parseFloat(ef_pointvirgule($("#lengthinput").val()));
	if (isNaN(reqtime) || reqtime==PStotalTime || reqtime>600 || reqtime<1)	return;
	// pourcentage de réduction / augmentation
	var pc=reqtime/PStotalTime;
	// appliquer à l'ensemble
	chgAllTime(PSroot,pc);
	PSactualTime*=pc;
	PStotalTime*=pc;
	_O(0).length=PStotalTime;
	//PSactualTime=PStotalTime;
	ps_drawTimeLine();
	ps_posiTimeLine();
	// effacement de la sélection
	var tmp=PSselected;
	ps_selectObject(0);
	if (tmp)	ps_selectObject(tmp);
	// visuel
	ps_getEffects(PSroot,0);
	ef_feedback(1);
}
function ef_feedback(fd)
{
	if (!fd)			$("#div-timeline-effects").css("background-color","");
	else
	{
		if (fd==1)
		{
			PSChg++;
			$("#div-timeline-effects").css("background-color","#AFA");
		}
		else			$("#div-timeline-effects").css("background-color","#FAA");
		setTimeout(ef_feedback,1000);
	}
}

function chgAllTime(uid,pc)
{
	var object=_O(uid);
	chgALlEffects(object.firsteffect,pc);
	if (object.firstchild)	chgAllTime(object.firstchild,pc);
	if (object.next)		chgAllTime(object.next,pc);
	return;
}
function chgALlEffects(uid,pc)
{
	var effect;
	do {
		effect=_O(uid);
		effect.time*=pc;
		//console.log("Change effet "+uid+" : pc = "+(effect.time*pc));
		uid=effect.next;
	}
	while (uid);
}
/* changer la longueur du film */
function ps_addtime()
{
	var reqtime=parseFloat(ef_pointvirgule($("#lengthinput").val()));
	if (isNaN(reqtime) || reqtime==PStotalTime || reqtime>600 || reqtime<1)
	{
		ef_feedback(-1);
		return;
	}
	if (reqtime>PStotalTime)
	{
		PStotalTime=reqtime;
		_O(0).length=PStotalTime;
		ps_drawTimeLine();
		ef_feedback(1);
		return;
	}
	if (reqtime<findBigTime(PSroot,0))
	{
		ps_Msg("<span style='color:red;'>"+_translate("Impossible de couper : signet présent.")+"</span>");
		ef_feedback(-1);
		return;
	}
	/* on peut couper */
	PStotalTime=reqtime;
	_O(0).length=PStotalTime;
	if (PSactualTime>PStotalTime)	PSactualTime=PStotalTime;
	ps_drawTimeLine();
	ef_feedback(1);
}
/* Chercher le plus grand .time */
function findBigTime(uid,time)
{
	var object=_O(uid);
	var mytime=findlastEff(object.firsteffect);
	if (mytime>time)	time=mytime;
	if (object.firstchild)	time=findBigTime(object.firstchild,time);
	if (object.next) 		time=findBigTime(object.next,time);
	return time;
}
function findlastEff(uid)
{
	var effect=_O(uid);
	while (effect.next)	effect=_O(effect.next);
	return effect.time;
}
/************ Marquer les effets ************/
/* établir une marque */
function ps_markEffect()
{
	if (!PSselected)	return;
	if (pscopy.uid!=PSselected||pscopy.timestart===false||pscopy.timestop!==false)
	{
		// réinit
		pscopy.uid=PSselected;
		pscopy.timestart=PSactualTime;
		pscopy.timestop=false;
		$("#brepeffect").hide();
		$("#bremeffect").hide();
		ps_displayMark();
		return;
	}
	if (pscopy.timestart==PSactualTime)	return;
	pscopy.timestop=PSactualTime;
	if (pscopy.timestop<pscopy.timestart)
	{
		var tmp=pscopy.timestart;
		pscopy.timestart=pscopy.timestop;
		pscopy.timestop=tmp;
	}
		$("#brepeffect").show();
		$("#bremeffect").show();
		ps_displayMark();
}
/* display mark */
function ps_displayMark()
{
	//console.log("UID : "+pscopy.uid+" Start "+pscopy.timestart);
	if (PSselected!=pscopy.uid||pscopy.timestart===false)
	{
			if ($("#div-mark").length)	$("#div-mark").hide();
			return;
	}
	// on doit afficher la ligne
	if (!$("#div-mark").length)	$("#div-timeline-effects").append("<div id='div-mark'><div id='div-mark-start'></div><div id='div-mark-stop'></div></div>");
	var left=(pscopy.timestart*PSspaceSec);
	var right=0;
	if (pscopy.timestop!==false)
	{
		right=(pscopy.timestop*PSspaceSec);
		$("#div-mark-stop").show();
	}
	else
	{
		right=(left+14);
		$("#div-mark-stop").hide();
	}
	right=$("#div-timeline-effects").width()-right;
	$("#div-mark").css({"left": left+"px","right" : right+"px"});
	$("#div-mark").show();
}
/* Supprimer les effets */
function ps_removeEffect()
{
	if (pscopy.uid!=PSselected)	return;
	var srcuid=_O(pscopy.uid).firsteffect;
	// chercher le début à supprimer
	while (srcuid && _O(srcuid).time<pscopy.timestart)	srcuid=_O(srcuid).next;
	if (!srcuid)
	{
		ps_Msg(_translate("Pas de signet à supprimer"),1);
		return;
	}
	PSChg++;
	// on casse tout
	while (srcuid && _O(srcuid).time<=pscopy.timestop)
	{
		// chainage
		var effect=_O(srcuid);
		if (effect.prev!=0)
		{
			_O(effect.prev).next=effect.next;
			if (effect.next)	_O(effect.next).prev=effect.prev;
			PSobjChain[effect.uid]=null;
		}
		srcuid=effect.next;
	}
	ps_selectObject(0);
	ps_selectObject(pscopy.uid);
	ps_getEffects(pscopy.uid,0);	
}
/* dupliquer les effets */
function ps_repeatEffect()
{
	if (!PSselected)	return;
	// controle si PSactualTime n'est pas dans la zone à copier
	if (pscopy.uid==PSselected)
	{
		var endcp = PSactualTime+pscopy.timestop-pscopy.timestart;
		if ((PSactualTime>=pscopy.timestart && PSactualTime<=pscopy.timestop) || (endcp>=pscopy.timestart && endcp<=pscopy.timestop))
		{
			ps_Msg(_translate("Impossible de copier à l'intérieur de lui-même !"),true);
			return;
		}
	}
	var srcuid=_O(pscopy.uid).firsteffect;
	var dstuid=PSselected;

	// chercher le début à copier
	while (srcuid && _O(srcuid).time<pscopy.timestart)	srcuid=_O(srcuid).next;
	if (!srcuid)
	{
		ps_Msg(_translate("Pas de signet à copier"),1);
		return;
	}
	PSChg++;
	// on recopie
	while (srcuid && _O(srcuid).time<=pscopy.timestop && (PSactualTime+_O(srcuid).time-pscopy.timestart)<=PStotalTime)
	{
		var dsttime=_O(srcuid).time+PSactualTime-pscopy.timestart;
		var tmp=JSON.stringify(_O(srcuid));
		var newEffect=JSON.parse(tmp);
		var inserteffect=ps_getInsertEffect(dstuid,dsttime);
		// chainage
		PSobjChain[PSuid]=newEffect;
		newEffect.uid=PSuid++;
		newEffect.prev=inserteffect;
		newEffect.next=_O(inserteffect).next;
		newEffect.time=dsttime;
		newEffect.parent=dstuid;
		_O(inserteffect).next=newEffect.uid;
		if (newEffect.next)	_O(newEffect.next).prev=newEffect.uid;
		srcuid=_O(srcuid).next;
	}

	ps_selectObject(0);
	ps_selectObject(dstuid);
	ps_getEffects(dstuid,0);
}
function ps_getInsertEffect(uid,time)
{
		var effect=_O(uid).firsteffect;
		while (_O(effect).next&&_O(_O(effect).next).time<=time)		effect=_O(effect).next;
		return effect;
}
/* change , en . dans les inputs effets */
function ef_pointvirgule(val)
{
	return val.replace(/,/g,'.');
}
