/* Mouse wheel */
function psm_wheel(ev)
{
	if (ev.deltaY==undefined)	return;
	var z;
	if (ev.deltaY<0)	z=(PSMzz*100)+1+2*PSMzz;
	else			z=(PSMzz*100)-1-2*PSMzz;
	z=Math.round(z);
	if (z>400)	z=400;
	if (z<25)	z=25;
	psm_zoomit(false,false,z);
	$("#range-zoom").val(PSMzz*100);
	psm_zoomtxt(PSMzz*100);
	// temporaire
	//if (PSedEffect)	eff_chgEffect(_O(PSedEffect).parent);
}

/* Multisystème */
var PSMuid=0;
var PSMx=0;
var PSMy=0;
var PSMtz;				// distance entre les doigts
var PSMon=false;		// true si drag & drop 
var PSMtype=0;			//1 souris / 2 tablette
function psm_Start(ev,uid)
{
	if (uid>0 && _O(uid).type==undefined && PSlockEffect)
	{
		ps_clickEffect(uid);
		return;
	}
	/* unlock */
	if (uid>0)	PSMon=true;
	else
	{
		if (PSMon)	return;
		if (uid==0)			$('#div-time').show();
	}
	ev.preventDefault();
	PSMtype=0;
	PSMuid=uid;
	if (ev.buttons==1)
	{
		PSMtype=1;
		PSMx=ev.clientX;
		PSMy=ev.clientY;
		$(document).on("mouseup",psm_End);
		$(document).on("mousemove",psm_Move);
		$(document).on("mouseleave",psm_Cancel);
	}
	else if (ev.touches!=undefined)
	{
		PSMtype=2;
		if (ev.touches[1]!=undefined)
		{
			PSMx=(ev.touches[0].pageX+ev.touches[1].pageX)/2;
			PSMy=(ev.touches[0].pageY+ev.touches[1].pageY)/2;
			PSMtz=calc_fingdist(ev.touches[0].pageX,ev.touches[1].pageX,ev.touches[0].pageY,ev.touches[1].pageY);
		}
		else
		{
				PSMx=ev.touches[0].pageX;
				PSMy=ev.touches[0].pageY;
		}
		$(document).on("touchend",psm_End);
		$(document).on("touchmove",psm_Move);
		$(document).on("touchcancel",psm_Cancel);
	}
}
// effacer source et placer image
var PrepW=0;
function psm_prepmove(uid)
{
	if (_O(uid).type!=undefined)
	{
		$("#objline"+uid).css("opacity",.5);
		var w=$("#objline"+uid).width();
		var h=$("#objline"+uid).height();
		$("#div-drag").width(w);
		$("#div-drag").height(h);
		$("#objline-hole").width(w);
		PrepW=w;
	}
	else
	{
		$("#div-drag").width("");
		$("#div-drag").height("");
	}
}
/* mouse move ou touchmove */
function psm_Move(ev)
{
	var	psmx,psmy,psmz;
	//ps_Msg("PSMType"+PSMtype);
	if (PSMtype==2)
	{
		if (ev.touches[1]!=undefined)
		{
			// position
			psmx=(ev.touches[0].pageX+ev.touches[1].pageX)/2;
			psmy=(ev.touches[0].pageY+ev.touches[1].pageY)/2;
			psmz=calc_fingdist(ev.touches[0].pageX,ev.touches[1].pageX,ev.touches[0].pageY,ev.touches[1].pageY);
		}
		else
		{
				psmx=ev.touches[0].pageX;
				psmy=ev.touches[0].pageY;
		}
	}
	else
	{
		psmx=ev.clientX;
		psmy=ev.clientY;
	}
	/* event drag & drop */
	if (PSMuid>0)
	{
		PSMx=psmx;
		PSMy=psmy;
		var obj=_O(PSMuid);
		if ($("#div-drag").css("display")!="block")
		{
			$("#div-drag").removeClass();
			if (obj.type!=undefined)		$("#div-drag").addClass("drag-line");
			else							$("#div-drag").addClass("drag-effect");
			psm_prepmove(PSMuid);
			$("#div-drag").show();
		}
		var corx,cory;
		if (obj.type!=undefined)
		{
			psm_autoscroll(PSMy,"#div-right");
			psm_gethole();
			corx=-PrepW+10;
			//cory=-32;
			cory=10;
		}
		else						{corx=-5; cory=-25;}
		$("#div-drag").css({"left":PSMx+corx,"top":PSMy+cory});
	}
	// Déplacement barre de temps
	else if (PSMuid==0)
	{
		if (PSMon)	return;
		var mov=psmx-PSMx;					// différence de mouvement
		var time=PSactualTime-(mov/PSspaceSec);
		if (time<0)	time=0;
		if (time>PStotalTime)	time=PStotalTime;
		if (time==PSactualTime)	return;
		PSactualTime=Math.round(time*100)/100;
		PSMx=psmx;
		PSMy=psmy;
		ps_posiTimeLine();
		ps_getEffects(PSroot,0);
	}
	// Déplacement fenêtre effet
	else if (PSMuid==-1)
	{
		//Déplacement vertical des effets
		//var pos=$('#ef-bar').position();
		var movy=psmy-PSMy;		//+pos.top;
		PSMy=psmy;
		TopEffet=TopEffet+movy;
		if (TopEffet<70)	TopEffet=70;
		else if (TopEffet>(RightH-70))	TopEffet=RightH-70;
		$("#div-neweffect").height(RightH-TopEffet-30);
		$("#div-right").height(TopEffet);
	}
	// Déplacement preview
	else if (PSMuid==-2)
	{
		var movx=psmx-PSMx;
		var movy=psmy-PSMy;
		if (PSedEffect)
		{
			eff_moveObject(movx,movy);
			PSMx=psmx;
			PSMy=psmy;
			PSChg++;
			return;
		}
		var pos=$('#div-zoom').offset();
		var diff=PSMtz-psmz;
		PSMx=psmx;
		PSMy=psmy;
		PSMtz=psmz;
		if (Math.abs(diff)>1)
		{
			var z;
			if (diff<0)	z=(PSMzz*100)+1+2*PSMzz;
			else			z=(PSMzz*100)-1-2*PSMzz;
			z=Math.round(z);
			if (z>400)	z=400;
			if (z<25)	z=25;
			psm_zoomit(movx,movy,z);
			$("#range-zoom").val(PSMzz*100);
			psm_zoomtxt(PSMzz*100);
		}
		else		psm_zoomit(movx,movy);
	}
}
/* calcul de la distance entre deux points (deux doigts) */
function calc_fingdist(x1,x2,y1,y2)
{
	return Math.sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
}
/* mouse up ou touchend */
function psm_End(ev)
{
	PSMon=false;
	/* fin des events si mouseup ou touchend */
	if (PSMtype==2)
	{
		$(document).off("touchend");
		$(document).off("touchmove");
		$(document).off("touchcancel");
	}
	else
	{
		$(document).off("mouseup");
		$(document).off("mousemove");
		$(document).off("mouseleave");
	}
	/* si drag & drop */
	if (PSMuid>0)
	{
		// click sur l'élément et non drag
		if ($("#div-drag").css("display")!="block")
		{
			if (_O(PSMuid).time!=undefined)			ps_clickEffect(PSMuid);
			else																ps_selectObject(PSMuid);
			return;
		}
		// drag & drop
		$("#div-drag").hide();
		// déplacement d'un effet
		if (_O(PSMuid).time!=undefined)	
		{
			/* test des limites du ruban */
			var y1=$("#div-timelineleft").offset().top;
			var y2=$("#div-timelineleft").height()+y1;
			if (PSMy>y1 && PSMy<y2) PS_moveEffect(PSMuid,(PSMx-$("#div-timeline-ruban").position().left-3)/PSspaceSec);
		}
		else
		{
			$("#objline-hole").hide();
			$("#objline"+PSMuid).css("opacity",1);
			var uid=psob_getobject(PSMx,PSMy);
			if (!uid)	return;
			PSChg++;
			psob_cutpaste(PSMuid,uid);	// src / dst
		}
	}
	else			$('#div-time').hide();
}
/* Mettre espace vide si drag&drop */
function psm_gethole()
{
	var uid=psob_getobject(PSMx,PSMy);
	if (!uid || PSMuid==uid || (_O(PSMuid).type==1 && psob_getchild(_O(PSMuid).uid,_O(uid).uid)))
	{
		$("#objline-hole").hide();
	}
	else
	{
		$("#objline-hole").insertAfter("#objline"+uid);
		$("#objline-hole").show();
	}
}
/* annulation drag & drop */
function psm_Cancel(ev)
{
	PSMon=false;
	$("#div-drag").hide();
	/* fin des events si mouseup ou touchend */
	if (PSMtype==2)
	{
		$(document).off("touchend");
		$(document).off("touchmove");
		$(document).off("touchcancel");
	}
	else
	{
		$(document).off("mouseup");
		$(document).off("mousemove");
		$(document).off("mouseleave");
	}
	if (PSMuid)
	{
		$("#objline"+PSMuid).css("opacity",1);
		$("#objline-hole").hide();
	}
}
var clickTimer=null;
/* double tab poubelle */
function psm_deleteObject(ev,uid) {
    if (clickTimer == null)
    {
		ps_Msg(_translate("Double-click pour supprimer"));
		if (uid)	$("#obtrash"+uid).attr("src","data/newicons/trashclick.svg");
		clickTimer = setTimeout(function ()
		{
				if (uid)	$("#obtrash"+uid).attr("src","data/newicons/trash.svg");
				clickTimer = null;
			}, 500);
	}
	else
	{
		clearTimeout(clickTimer);
		$("#sysmsg").html("");
		clickTimer = null;
		// nature de l'objet
		if (uid==0)		ps_deleteEffect();		// supprimer l'effet en cours
		else			ps_deleteObject(uid);	// supprimer un objet
	}
	ev.preventDefault();
}
/* double tap sur un input */
function psm_inputTouch(ev,uid) {
	if (PSselected!=uid)
	{
		ps_selectObject(uid);
		return;
	}
	if ($('#objname'+uid).length==0)	ev.preventDefault();
	else								return;
    if (clickTimer == null)
    {
	ps_Msg(_translate("Double-click pour éditer"));
        clickTimer = setTimeout(function ()
	{
            clickTimer = null;
        }, 500);
    }
    else
	{
		clearTimeout(clickTimer);
		$("#sysmsg").html("");
		clickTimer = null;
		$("#obname"+uid).html("<input type='text' value='"+_O(uid).name+"' id='objname"+uid+"' onchange='ps_changeName("+uid+")' />");
		$("#objname"+uid).focus();
	}
}
// changer le nom d'un objet
function ps_changeName(uid)
{
	PSChg++;
	var newname=$("#objname"+uid).val();
	if (newname)	_O(uid).name=newname;
	$("#obname"+uid).html(extname(newname));
}
/* gestion du scroll lors d'un drag/drop */
function psm_autoscroll(y,id)
{
	var sy=$(id).scrollTop();
	var h=$(id).height();
	var oy1=$(id).offset().top;
	oy1=Math.round(oy1);
	var oy2=h+oy1;
	//ps_Msg("Sy "+sy+" y "+y+" oy1 "+oy1+" oy2 "+oy2);
	if (sy&&y<oy1)
	{
		var newsy=sy-(oy1-y);
		if (newsy<0)	newsy=0;
		$(id).scrollTop(newsy);
	}
	else if (y>=oy2)
	{
		var newsy=sy+(y-oy2);
		//if (newsy<0)	newsy=0;
		$(id).scrollTop(newsy);
	}
}
/* Zoom */
function psm_center()
{
	$("#range-zoom").val(100);
	psm_zoomtxt(100);
	psm_zoomit(0,0,100,true);
}
function psm_zoomzoom()
{
	var zoom=$("#range-zoom").val();
	psm_zoomtxt(zoom);
	psm_zoomit(false,false,zoom,false);
}
function psm_zoomtxt(zoom)
{
	$("#range-text").html(Math.round(zoom)+"%");
}
var PSMzx,PSMzy,PSMzz;
function psm_zoomit(x,y,z,absolute)
{
	if (z==undefined)			z=false;
	if (absolute==undefined)	absolute=false;
	// rectification position
	if (x!==false)
	{
		if (absolute)
		{
			PSMzx=x;
			PSMzy=y;
		}
		else
		{
			PSMzx+=x;
			PSMzy+=y;
		}
	}
	// rectification zoom
	if (z!==false)
	{	
		PSMzz=z/100;
		$("#div-zoom").css("transform","scale("+PSMzz+")");
	}
	// changement positions
	$("#div-zoom").css({"left":PSMzx+"px","top":PSMzy+"px"});
	// border
	$("#div-zoomborder").width(prev_width*PSMzz);
	$("#div-zoomborder").height(prev_height*PSMzz);
	var nleft=PSMzx+(prev_width*(1-PSMzz)*.5);
	var ntop=PSMzy+(prev_height*(1-PSMzz)*.5);
	$("#div-zoomborder").css({"left":nleft+"px","top":ntop+"px"});
	// afficher widget
	if (PSMzz!=1 || PSMzx!=0 || PSMzy!=0)	$("#zoom-center").show();
	else			$("#zoom-center").hide();
	ps_butresize();
	ps_resizebuttons();
	if (PSedEffect)	eff_chgEffect(_O(PSedEffect).parent);
}
/********** Gestion de la visualisation des objets ***********/
function eff_showEffect(show)
{
	if (show)	$("#effect-preview").show();
	else	
	{
		$("#effect-preview").hide();
		$("#effect-preview-parent").hide();
	}
}
function eff_chgEffect(uid,isparent)	// isparent peut être omis
{
	var tmpdisplay=false;
	if ($("#pobject"+uid).css("display")=="none")
	{
		tmpdisplay=true;
		$("#pobject"+uid).show();
	}
	var rect=$("#pobject"+uid)[0].getBoundingClientRect();

	if (tmpdisplay)	$("#pobject"+uid).hide();
	var object=_O(uid);
	if (isparent)	var addid="-parent";
	else			var addid="";
	$("#effect-preview"+addid).show();

	if (object.type>=2||object.actualeffect.width!==false)
	{
		$("#effect-preview"+addid).width(rect.width);
		$("#effect-preview"+addid).height(rect.height);
		$("#effect-preview"+addid).removeClass();
		$("#effect-preview"+addid).addClass("effect-plain");
	}
	else
	{
		$("#effect-preview"+addid).width(31);
		$("#effect-preview"+addid).height(31);
		$("#effect-preview"+addid).removeClass();
		$("#effect-preview"+addid).addClass("effect-target");
	}
	$("#effect-preview"+addid).css({"left":rect.left-10,"top":rect.top-10});
	if (!isparent && object.parent)	eff_chgEffect(object.parent,true);
}

/* Déplacement d'un objet si openeffect */
function eff_moveObject(movx,movy)
{
	var effect=_O(PSedEffect);
	// on transforme en pc%
	var uid=effect.parent;
	movx=movx/(prev_width);
	movy=movy/(prev_height);
	// zoom
	var zoom=eff_getZoom(PSedEffect)*PSMzz;
	//ps_Msg("Zoom : "+zoom);
	movx/=zoom;
	movy/=zoom;
	if (!(effect.flag&EFFECT_X) && !(effect.flag&EFFECT_Y))
	{
		//ps_Msg("Alert");
		//effect.flag=effect.flag|EFFECT_X;
		//effect.flag=effect.flag|EFFECT_Y;
		ef_chgsimple(effect,EFFECT_X);
		ef_chgsimple(effect,EFFECT_Y);
	}
	// changer
	if (effect.flag&EFFECT_X)
	{
		effect.x+=movx;
		$("#ef-value"+EFFECT_X).val(effect.x*100);
	}
	if (effect.flag&EFFECT_Y)
	{
		effect.y+=movy;
		$("#ef-value"+EFFECT_Y).val(effect.y*100);
	}
	ps_modifyPreviewObject(uid,effect,effect.flag&(EFFECT_X|EFFECT_Y));
	eff_chgEffect(uid);
}
/* trouver la valeur du zoom total d'une image */
function eff_getZoom(uid)
{
	var object=_O(uid);
	var zoom=1;	//object.zoom;
	object=_O(object.parent);
	if (!object)	return zoom;
	while (object.parent)
	{
		object=_O(object.parent);
		zoom*=object.actualeffect.zoom;
	}
	return zoom;
}
/* popup en cas de demo */
function ps_isdemo(msg)
{
	var html="<div id='drawerpopup'><h1>"+_translate("Version de démonstration")+"</h1>";
	html+="<div class='infoblock'>"+msg+"</div>";
	html+="<div class='infoblock'>"+_translate("Cette fonction n'est pas disponible en mode démonstration.")+"</div>";
	html+="<div style='text-align:center;' ><p onclick='ps_cancel()' class='button'>"+_translate("Fermer")+"</p></div></div>";
	$("#popuplock").html(html);
	$("#popuplock").css("background-color","rgba(0,0,0,.5)");
	$("#popuplock").show();
}