/* Gestion du son */
/* demander chargement de la liste des sons */
var WAsoundList=0;
var WAselected=0;
function wa_listesons()
{
	// composer liste des sons pour liste déroulante en fonction du projet
	pj_lock("deroulson");
	var drawer=PJSceneList[PJSelected][1];
	$.post("pjutil.php",{command:"listson",scene:drawer}, function (data) {
	var retour=_parse(data);
	if (retour[0]==1)	wa_addsons(retour[1]);
	pj_unlock();
	});
}
function wa_addsons(liste)
{
	WAsoundList=liste;
	WAselected=0;
	var chemin="projects/"+PJProject+"/commons/sounds/";
	for (i=1;i<liste.length;i++)
	{
		var sound="";

		if (WAsoundList[0][0]==liste[i][0])
		{
			var bcolor="background-color:#55F;";
			WAselected=i;
		}
		else var bcolor="";
		sound+="<div class='li_divsnd' onclick='wa_click("+i+")' id='son-"+i+"' style='"+bcolor+"background-image:url(\""+chemin+"S20-"+liste[i][1]+".png\"); '>";
		sound+="<div class='li_txt'>";
		sound+="<div class='li_txt' style='display:block'>"+liste[i][0]+"</div>";
		sound+="<div class='li_txt'>"+_translate("Durée")+" : "+parseFloat(liste[i][2]).toFixed(1)+" "+_translate("secondes")+"</div>";
		sound+="</div><div class='li_trash' style='top:3px;' onclick='wa_deleteson(event,"+i+")'></div></div>";
		$('#listesons').append(sound);
	}
}
/* cliquer un son */
function wa_click(id)
{
	if (WAselected||WAselected==id)
	{
		$("#son-"+WAselected).css("background-color","");
		if (WAselected==id)
		{
			WAselected=0;
			return;
		}
	}
	WAselected=id;
	$("#son-"+id).css("background-color","#55F");
}
/* sauver son */
function wa_savezero()
{
	if (!WAselected)
	{
		WAsoundList[0][0]="";
		WAsoundList[0][1]="";
		WAsoundList[0][2]=0;
		WAsoundList[0][3]=0;
	}
	else
	{
		WAsoundList[0][0]=WAsoundList[WAselected][0];
		WAsoundList[0][1]=WAsoundList[WAselected][1];
		WAsoundList[0][2]=WAsoundList[WAselected][2];
		WAsoundList[0][3]=WAsoundList[WAselected][3];
	}
	$.post("pjutil.php",{command:"chgson",scene:PJSceneList[PJSelected][1],snd:WAsoundList[0][0],spsnd:WAsoundList[0][1],sndlen:WAsoundList[0][2],sndstrt:WAsoundList[0][3]}, function (data) {
	var retour=_parse(data);
	if (retour[0]=="1")	$('#upmsgsnd').html(_translate("Sauvegarde effectuée"));
	else							$('#upmsgsnd').html(retour[1]);
	});	

}
/* ajouter un son */
function wa_addsound(event)
{
	// fonction de chargement d'un son (pour commons)
	var sound=event.target.files;
	var data = new FormData();
	idx=0;
	data.append("project",PJProject);
	data.append("scene",PJSceneList[PJSelected][1]);
	data.append("mode","snd");
	while (sound[idx]!=undefined)	data.append('snd-'+idx,sound[idx++]);
	// progress bar
	$("#uploadbarsnd").show();
	$('#upmsgsnd').html(_translate("Chargement en cours")+" ("+sound.length+")");
	// upload
	$.ajax({
		url: 'pjupload.php',
		data: data,
		cache: false,
		contentType: false,
		processData: false,
		type: 'POST',
		xhr: function() {
			var myXhr = $.ajaxSettings.xhr();
			if (myXhr.upload)	myXhr.upload.addEventListener('progress',up_progresssnd, false);
			return myXhr;},
		success: up_successsnd
	});
}
/* Supprimer un son */
function wa_deleteson(event,idx)
{
	event.stopPropagation();
	if (pj_closepop())	return;
	var pop="";
	pop+="<h1>"+_translate("Supprimer un son")+"</h1>";
	pop+="<p>"+_translate("Êtes-vous bien sûr de vouloir supprimer :")+"<br>";
	pop+="<b>"+WAsoundList[idx][0]+"</b>&nbsp;?</p>";
	pop+="<p>"+_translate("Attention, si ce son est utilisé dans une scène, celle-ci devra être modifiée !")+"</p>";
	pop+="<div class='errordiv' id='fu_err'></div>";
	pop+="<div id='leftbutton' onclick='pj_closepop();'>"+_translate("Annuler")+"</div>";
	pop+="<div id='rightbutton' onclick='wa_supprsonvalid("+idx+");' style='color:red'>"+_translate("Supprimer")+"</div>";
	pop+="</div>";
	/* display */
	$("#popup").html(pop);
	//$("#popup").show();
	ShowPop(true);
	event.preventDefault();
}
function wa_supprsonvalid(idx)
{
	var name=WAsoundList[idx][1];
	$('#fu_errproj').html("");
	$.post("pjutil.php",{command:"supprson",sndname:name}, function (data) {
	var retour=_parse(data);
	if (retour[0]=="1")
	{
		/* supprimer si son utilisé dans scène */
		if (WAsoundList[0][0]==WAsoundList[idx][0])
		{
			WAselected=0;
			wa_savezero();
		}
		/* supprimer dans la liste */
		$('#son-'+idx).remove();
		WAsoundList[idx]=null;
		WAselected=0;
		pj_closepop();
	}
	else
	{
		/* afficher l'erreur */
		$('#fu_err').html(retour[1]);
	}
	});	
}
/* hooks */
function up_progresssnd(event)
{
	$('#uploadbarsnd').attr("max",event.total);
	$('#uploadbarsnd').val(event.loaded);
	if (event.loaded==event.total)	$('#upmsgsnd').html(_translate("Conversion des fichiers..."));
}
function up_successsnd(result)
{
	$("#uploadbarsnd").hide();
	if (result.indexOf("<b>Warning</b>")!=-1)
	{
		$('#upmsgsnd').html(_translate("Avertissement : erreur de chargement !"));
		return;
	}
	var retour=_parse(result);
	if (retour[1])
	{
		$('#listesons').html("");
		wa_listesons();
	}
	if (retour[0])	$('#upmsgsnd').html(_translate("Il y a eu des erreurs !")+"("+retour[0]+")");
	else			$('#upmsgsnd').html(_translate("Chargement terminé !"));
}
/*-t duration (input/output)

    When used as an input option (before -i), limit the duration of data read from the input file.

    When used as an output option (before an output url), stop writing the output after its duration reaches duration.

    duration must be a time duration specification, see (ffmpeg-utils)the Time duration section in the ffmpeg-utils(1) manual.

    -to and -t are mutually exclusive and -t has priority.
-ss position (input/output)

    When used as an input option (before -i), seeks in this input file to position. Note that in most formats it is not possible to seek exactly, so ffmpeg will seek to the closest seek point before position. When transcoding and -accurate_seek is enabled (the default), this extra segment between the seek point and position will be decoded and discarded. When doing stream copy or when -noaccurate_seek is used, it will be preserved.

    When used as an output option (before an output url), decodes but discards input until the timestamps reach position.

    position must be a time duration specification, see (ffmpeg-utils)the Time duration section in the ffmpeg-utils(1) manual
The following examples are all valid time duration:

‘55’

    55 seconds
‘12:03:45’

    12 hours, 03 minutes and 45 seconds
‘23.189’

    23.189 seconds 
*/