<?php
	// Commandes utiles
	session_name('index'); 
	session_start();
	if (!isset($_POST['command']))	exit("Error !");
	$retour=array();
	$cmd=$_POST['command'];
	require_once ("projects/users.php");
	require_once ("lng/lng.php");
	switch ($cmd)
	{
		/* tasks */
		case "deltask":
			if (!($ADMFlags&1) || hash('sha256',$_POST['password'])==$ADMMdp)
			{
				$id=$_POST['ident'];
				if (!file_exists("tasks/$id.tsk"))	$retour[0]="1";
				else
				{
					unlink("tasks/$id.tsk");
					if (file_exists("tasks/$id.dat"))	unlink("tasks/$id.dat");
					// tester si la tâche locke
					if (file_exists("tasks/pst.lock"))
					{
						$lock=file_get_contents("tasks/pst.lock");
						$lock=explode("\n",$lock);
						if ($lock[0]==$id)	unlink("tasks/pst.lock");
					}
					$retour[0]="1";
				}
			}
			else
			{
				$retour[0]="0";
				$retour[1]=_translate("Mot de passe incorrect !");
			}
			break;
		case "stoptask":
			if (!($ADMFlags&1) || hash('sha256',$_POST['password'])==$ADMMdp)
			{
				$id=$_POST['ident'];
				if (!file_exists("tasks/$id.tsk"))
				{
					$retour[0]="1";
					$retour[1]="1";
				}
				else
				{
					$content=file_get_contents("tasks/$id.tsk");
					$content=explode("\n",$content);
					$content[0]="<stop>";
					file_put_contents("tasks/$id.tsk",implode("\n",$content));
					$retour[0]="1";
					$retour[1]="0";
				}
			}
			else
			{
				$retour[0]="0";
				$retour[1]=_translate("Mot de passe incorrect !");
			}
			break;
		/* Choix d'un projet */
		case "openproj":
			//$.post("idxutil.php",{command:"openproj",password:"",index:ProjectID}
			$index=$_POST['index']-1;
			$liste=$_SESSION['projlist'][$index];
			$chemin="projects/".$liste[0];
			$passwd=$_POST['password'];
			// regarder si répertoire existe bien
			if (!is_dir($chemin))
			{
				$retour[0]="0";
				$retour[1]=_translate("Le répertoire n'existe pas !")." (".$liste[0].")";
				break;
			}
			if (file_exists("$chemin/mdp.txt"))
			{
				$key=file_get_contents("$chemin/mdp.txt");
				if (!$passwd)
				{
					$retour[0]="1";
					$retour[1]="";
				}
				else
				{
					if (hash('sha256',$passwd)==$key)
					{
						$retour[0]="2";
						$_SESSION['project']=$liste[0];
						$_SESSION['projname']=$liste[2];
					}
					else
					{
						$retour[0]="1";
						$retour[1]=_translate("Mot de passe incorrect !");
					}
				}
			}
			else
			{
				$retour[0]="2";
				$_SESSION['project']=$liste[0];
				$_SESSION['projname']=$liste[2];
			}
			break;
		/* Maj */
		case "getmaj":
			header("Cache-Control: no-cache, must-revalidate");
			header("Cache-Control: post-check=0,pre-check=0");
			header("Cache-Control: max-age=0");
			header("Pragma: no-cache");
			header("Expires: 0");
			require_once("include/cfg.php");
			require_once ("include/version.php");
			require_once ("projects/users.php");
			require_once ("lng/lng.php");
			if (!it_exists(PS_MAJADRS."/VERSION"))
			{
				$retour[0]="0";
				$retour[1]=_translate("Adresse de mise à jour introuvable !");
			}
			else
			{
				$nversion=file_get_contents(PS_MAJADRS."/VERSION");
				$nversion=str_replace("\n","",$nversion);
				$aversion="".PS_VERSION*100;
				if ($aversion>=$nversion)	//($aversion>=$nversion)
				{
					$retour[0]="1";
					//$retour[1]="Retour 1 / $aversion / $nversion";
				}
				else
				{
					$retour[0]="2";
					//$retour[1]="Retour 2 / $aversion / $nversion";
					$retour[1]=$nversion/100;
				}
			}
			break;
		/* suppr */
		case "supprproj":
			if (!($ADMFlags&1) || !($ADMFlags&16) || hash('sha256',$_POST['password'])==$ADMMdp)
			{
				/* nom répertoire */
				$index=$_POST['index']-1;
				$liste=$_SESSION['projlist'];
				$drawer=$liste[$index][0];
				if (!file_exists("projects/$drawer"))
				{
					$retour[0]="0";
					$retour[1]=_translate("Le répertoire n'existe pas !")." ($drawer)";
					break;
				}
				/* Suppression */
				if ($drawer!="")	rrmdir("projects/$drawer");
				/* tout va bien */
				$retour[0]="1";
			}
			else
			{
				$retour[0]="0";
				$retour[1]=_translate("Mot de passe incorrect !");
			}
			break;
		/* importer un projet */
		//$.post("idxutil.php",{command:"importproject",password:mdp,archivename:archive}
		case "importproject":
			if (hash('sha256',$_POST['password'])==$ADMMdp)
			{
				/* nom projet */
				$archive=$_POST['archivename'];
				if (!file_exists("archives/$archive"))
				{
					$retour[0]="0";
					$retour[1]=_translate("L'archive n'existe pas !")." ($archive)";
					break;
				}
				else
				{
					require_once("include/cfg.php");
					ps_exec(PS_UNZIP." archives/$archive");
					$decoupe=explode("@",$archive);
					//création des images
					$chemin="projects/".$decoupe[0];
					$dir=scandir($chemin);
					foreach($dir as $entry)
					{
						if ($entry!='.' && $entry!='..' && is_dir("$chemin/$entry"))	CreateImageCache("$chemin/$entry");
					}
					$retour[0]="1";
					break;
				}
			}
			else
			{
				$retour[0]="0";
				$retour[1]=_translate("Mot de passe incorrect !");
			}
			break;
		/* lister les archives */
		case "listarch":
			$liste=listfiles("archives","zip");
			if (!$liste)
			{
				$retour[0]="0";
				$retour[1]=_translate("Aucune archive trouvée !");
			}
			else
			{
				$retour[0]="1";
				$retour[1]=implode("|",$liste);
			}
			break;
		/* archive */
		//$.post("idxutil.php",{command:"archproject",password:mdp,archflag:flag,index:ProjectID}
		case "archproject":
			if (hash('sha256',$_POST['password'])==$ADMMdp)
			{
				/* nom répertoire */
				$index=$_POST['index']-1;
				$liste=$_SESSION['projlist'];
				$drawer=$liste[$index][0];
				if (!file_exists("projects/$drawer"))
				{
					$retour[0]="0";
					$retour[1]=_translate("Le répertoire n'existe pas !")." ($drawer)";
					break;
				}
				/* Flag */
				$flag=$_POST['archflag'];
				$archive=archiveDrawerNew($drawer,$flag);
				$retour[1]=$archive;
				if ($archive[3])		$retour[0]="0";		// erreur !
				else							$retour[0]="1";		// ok !
			}
			else
			{
				$retour[0]="0";
				$retour[1]=_translate("Mot de passe incorrect !");
			}
			break;
		/* suite de l'archivage */
		//$.post("idxutil.php",{command:"archivenext",archive:ArchArchive,index:ArchIDX}, function (data) {
		case "archivenext":
			$archive=$_POST['archive'];
			$idx=$_POST['index'];
			$retour[0]=1;
			$retour[1]=archiveDrawerAdd($archive,$idx);
			break;
		/* changement mot de passe projet */
		case "chgprojmdp":
			if (!($ADMFlags&1) || !($ADMFlags&128) || hash('sha256',$_POST['password'])==$ADMMdp)
			{
				/* nom répertoire */
				$index=$_POST['index']-1;
				$liste=$_SESSION['projlist'];
				$drawer=$liste[$index][0];
				if (!file_exists("projects/$drawer"))
				{
					$retour[0]="0";
					$retour[1]=_translate("Le répertoire n'existe pas !")." ($drawer)";
					break;
				}
				/* mot de passe */
				$namedp="projects/$drawer/mdp.txt";
				if (!isset($_POST['projmdp'])||$_POST['projmdp']=="")
				{
					if (file_exists($namedp))	unlink($namedp);
				}
				else
				{
					file_put_contents($namedp,hash('sha256',$_POST['projmdp']));
				}
				/* tout va bien */
				$retour[0]="1";
			}
			else
			{
				$retour[0]="0";
				$retour[1]=_translate("Mot de passe incorrect !");
			}
			break;
		/* création nouveau projet */
		case "newproject":
			if (!($ADMFlags&1) || !($ADMFlags&8) || hash('sha256',$_POST['password'])==$ADMMdp)
			{
				/* filtre répertoire */
				$drawer=strict_filter($_POST['dname']);
				/* test existence répertoire */
				if (file_exists("projects/$drawer"))
				{
					$retour[0]="0";
					$retour[1]=_translate("Le répertoire existe déjà !")." ($drawer)";
					break;
				}
				/* création répertoire */
				if (!mkdir("projects/$drawer"))
				{
					$return[0]="0";
					$return[1]=_translate("Erreur lors de la création du répertoire !")." ($drawer)";
					break;
				}
				/* nom et mot de passe */
				file_put_contents("projects/$drawer/name.txt",$_POST['pname']);
				if ($_POST['projmdp'])	file_put_contents("projects/$drawer/mdp.txt",hash('sha256',$_POST['projmdp']));
				/* tout va bien */
				$retour[0]="1";
			}
			else
			{
				$retour[0]="0";
				$retour[1]=_translate("Mot de passe incorrect !");
			}
			break;
		/* changement de la configuration */
		case "chgconfig":
			$retour[0]="1";
			/* test de mot de passe */
			if ($ADMFlags&1)
			{
				if (hash('sha256',$_POST['mdp'])!=$ADMMdp)
				{
					$retour[0]="0";
					$retour[1]=_translate("Mot de passe incorrect !");
				}
			}
			if ($retour[0] && !is_numeric ($_POST['flags']))
			{
					$retour[0]="0";
					$retour[1]=_translate("Valeurs incorrectes !");
			}
			if ($retour[0])
			{
				if ($_POST['newmdp'])	$ADMMdp=hash('sha256',$_POST['newmdp']);
				$ADMFlags=$_POST['flags'];
				if (!($ADMFlags&1))			$ADMMdp="";
				$conf='<?php'."\n".'$ADMlng="'.$_POST['lang'].'";'."\n".'$ADMFlags='.$ADMFlags.';'."\n".'$ADMMdp="'.$ADMMdp.'";'."\n?>";
				file_put_contents("projects/users.php",$conf);
			}
			break;
		case "tmpcmd":
			$retour[0]="0";
			$retour[1]="Tmp command !";
			break;
		default:
			$retour[0]="0";
			$retour[1]="Invalid command !";
	}
	echo (json_encode($retour));
/* création archive */
function archiveDrawerNew($drawer,$flag)
{
	require_once("include/cfg.php");
	/* on fait la liste des scène et on prépare le terrain */
	$archname=$drawer."@".date("d-m-Y").".zip";
	$chemin="projects/$drawer";
	$err=0;
	addFile("archives/$archname","$chemin/name.txt",$err);
	addFile("archives/$archname","$chemin/mdp.txt",$err);
	addFile("archives/$archname","$chemin/commons/listmnt.txt",$err);

	/* composition de la liste de retour */
	$archive=array($drawer,$archname,$flag,$err,0);
	$dir=scandir($chemin);
	$nb=0;
	foreach($dir as $entry)
	{
		/*ajouter une scène */
		//archiveScene($archname,$chemin,$entry,$flag,$err);
		if ($entry!='.' && $entry!='..' && is_dir($chemin."/".$entry))	
		{
			$archive[]=$entry;
			$nb++;
		}
	}
	$archive[4]=$nb;
	return $archive;
}
function archiveDrawerAdd($archive,$idx)
{
		require_once("include/cfg.php");
		$chemin="projects/".$archive[0];
		$archname=$archive[1];
		$flag=$archive[2];
		$err=$archive[3];
		// [4] nombre de fichiers
		$entry=$archive[(5+$idx)];
		archiveScene($archname,$chemin,$entry,$flag,$err);
		$archive[3]=$err;
		return $archive;
}

/* archiver une scène */
function archiveScene($archive,$chemin,$scene,$flag,&$err)
{
	addFile("archives/$archive","$chemin/$scene/anim.name",$err);
	addFile("archives/$archive","$chemin/$scene/anim.pst",$err);
	addFile("archives/$archive","$chemin/$scene/$scene.jpg",$err);
	if ($flag&2)		addfile("archives/$archive","$chemin/$scene/sounds",$err);
	if ($flag&1)
	{
		if ($scene=="commons")
		{
			$videot=explode("/",$chemin);
			$video=$videot[1].".mp4";
		}
		else										$video=$scene.".mp4";
		addFile("archives/$archive","$chemin/$scene/$video",$err);
	}
	addimages("archives/$archive","$chemin/$scene/image",$err);
}
/* archiver les images */
function addimages($archive,$drawer,&$err)
{
	if (!is_dir($drawer))	return;
	$dir=scandir($drawer);
	foreach($dir as $entry)
	{
		if ($entry!='.' && $entry!='..' && is_file("$drawer/$entry"))
		{
			/*ajouter une image */
			$part=explode(".",$entry);
			$prefix=substr($entry,0,3);
			// Test du suffixe
			if (isset($part[1]) && ( strcasecmp($part[1],"jpg")==0 || strcasecmp($part[1],"png")==0 ))
			{
				// test du préfixe
				if ($prefix!="xs-" && !file_exists("$drawer/xl-$entry"))				addfile($archive,"$drawer/$entry",$err);
			}
		}
	}
}
/* archiver un fichier */
function addFile($archive,$file,&$err)
{
	if (!file_exists($file))	return;
	if (is_dir($file)) $recur="-r ";
	else					  $recur="";

	if (!ps_exec(PS_ZIP." $archive $recur$file"))	$err++;

}
/* envoyer liste des fichiers */
function listfiles($drawer,$extens)
{
	if (!is_dir($drawer))	return false;
	$dir=scandir($drawer);
	$liste=array();
	foreach($dir as $entry)
	{
		if ($entry!='.' && $entry!='..')
		{
			$part=explode(".",$entry);
			if (isset($part[1]) && $part[1]==$extens)	$liste[]=$entry;
		}
	}
	return $liste;
}
/* Exécution des commandes exec */
function ps_exec($cmd)
{
	putenv('LANG=fr_FR.UTF-8');
	exec($cmd,$out,$status);
	if ($status)	return false;
	else			return true;
}
/* changement nom répertoire */
function strict_filter($string)
{
	return preg_replace('/[^a-z0-9_-]/', '', $string); 
}
// recursively remove a directory
function rrmdir($dir)
{
	require_once("include/cfg.php");
	if (!PS_WINDOWS)
	{
		exec("rm -rf $dir");
		return;
	}
    foreach(glob($dir . '/*') as $file) {
        if(is_dir($file))
            rrmdir($file);
        else
            unlink($file);
    }
    rmdir($dir);
}
/* Utilitaire de traitement d'images */
function CreateImageCache($scene)
{
	require_once("include/cfg.php");
	$drawer="$scene/image";
	if (!is_dir($drawer))	return false;
	/* Création d'un répertoire anim si n'existe pas */
	if (!file_exists("$scene/anim"))	mkdir("$scene/anim");
	// boucler sur les images
	$dir=scandir($drawer);
	foreach($dir as $entry)
	{
		if ($entry!='.' && $entry!='..' && is_file("$drawer/$entry"))
		{
			/* tester image */
			$part=explode(".",$entry);
			$prefix=substr($entry,0,3);
			if (isset($part[1]) && $prefix!="xs-" && ( strcasecmp($part[1],"jpg")==0 || strcasecmp($part[1],"png")==0 ))
			{
				// si la miniature n'existe pas la créer
				$basename=$entry;
				if ($prefix=="xl-")	$basename=substr($entry,3);
				if (!file_exists("$drawer/xs-$basename"))	exec(PS_CONVCMD." $drawer/$entry -resize x64 $drawer/xs-$basename");
				// si fichier xl- création du fichier normal
				if ($prefix=="xl-")
				{
					if (!file_exists("$drawer/$basename"))
					{
						$size=getimagesize("$drawer/$entry");
						if ($size[0]>=$size[1])	$resize=PS_USEXL."x";
						else					$resize="x".PS_USEXL;
						exec(PS_CONVCMD." $drawer/$entry -resize $resize $drawer/$basename");
					}
				}
			}
		}
	}
}
/* existence d'un fichier */
function it_exists($url){
   $headers=get_headers($url);
   return stripos($headers[0],"200 OK")?true:false;
}
?>